﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;

/// <summary>
/// Utils 的摘要说明
/// </summary>
public class Utils
{
    public static bool IsNumeric(object expression)
    {
        return expression != null && Utils.IsNumeric(expression.ToString());
    }
    public static bool IsNumeric(string expression)
    {
        bool result;
        if (expression != null)
        {
            if (expression.Length > 0 && expression.Length <= 11 && Regex.IsMatch(expression, "^[-]?[0-9]*[.]?[0-9]*$"))
            {
                if (expression.Length < 10 || (expression.Length == 10 && expression[0] == '1') || (expression.Length == 11 && expression[0] == '-' && expression[1] == '1'))
                {
                    result = true;
                    return result;
                }
            }
        }
        result = false;
        return result;
    }
    public static bool IsDouble(object expression)
    {
        return expression != null && Regex.IsMatch(expression.ToString(), "^([0-9])[0-9]*(\\.\\w*)?$");
    }
    public static string[] GetStrArray(string str)
    {
        return str.Split(new char[44]);
    }
    public static string GetArrayStr(List<string> list, string speater)
    {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < list.Count; i++)
        {
            if (i == list.Count - 1)
            {
                sb.Append(list[i]);
            }
            else
            {
                sb.Append(list[i]);
                sb.Append(speater);
            }
        }
        return sb.ToString();
    }
    public static bool StrToBool(object expression, bool defValue)
    {
        bool result;
        if (expression != null)
        {
            result = Utils.StrToBool(expression, defValue);
        }
        else
        {
            result = defValue;
        }
        return result;
    }
    public static bool StrToBool(string expression, bool defValue)
    {
        bool result;
        if (expression != null)
        {
            if (string.Compare(expression, "true", true) == 0)
            {
                result = true;
                return result;
            }
            if (string.Compare(expression, "false", true) == 0)
            {
                result = false;
                return result;
            }
        }
        result = defValue;
        return result;
    }
    public static int ObjToInt(object expression, int defValue)
    {
        int result;
        if (expression != null)
        {
            result = Utils.StrToInt(expression.ToString(), defValue);
        }
        else
        {
            result = defValue;
        }
        return result;
    }
    public static int StrToInt(string expression, int defValue)
    {
        int result;
        if (string.IsNullOrEmpty(expression) || expression.Trim().Length >= 11 || !Regex.IsMatch(expression.Trim(), "^([-]|[0-9])[0-9]*(\\.\\w*)?$"))
        {
            result = defValue;
        }
        else
        {
            int rv;
            if (int.TryParse(expression, out rv))
            {
                result = rv;
            }
            else
            {
                result = Convert.ToInt32(Utils.StrToFloat(expression, (float)defValue));
            }
        }
        return result;
    }
    public static float ObjToFloat(object expression, float defValue)
    {
        float result;
        if (expression != null)
        {
            result = Utils.StrToFloat(expression.ToString(), defValue);
        }
        else
        {
            result = defValue;
        }
        return result;
    }
    public static float StrToFloat(string expression, float defValue)
    {
        float result;
        if (expression == null || expression.Length > 10)
        {
            result = defValue;
        }
        else
        {
            float intValue = defValue;
            if (expression != null)
            {
                bool IsFloat = Regex.IsMatch(expression, "^([-]|[0-9])[0-9]*(\\.\\w*)?$");
                if (IsFloat)
                {
                    float.TryParse(expression, out intValue);
                }
            }
            result = intValue;
        }
        return result;
    }
    public static DateTime StrToDateTime(string str, DateTime defValue)
    {
        DateTime result;
        if (!string.IsNullOrEmpty(str))
        {
            DateTime dateTime;
            if (DateTime.TryParse(str, out dateTime))
            {
                result = dateTime;
                return result;
            }
        }
        result = defValue;
        return result;
    }
    public static DateTime StrToDateTime(string str)
    {
        return Utils.StrToDateTime(str, DateTime.Now);
    }
    public static DateTime ObjectToDateTime(object obj)
    {
        return Utils.StrToDateTime(obj.ToString());
    }
    public static DateTime ObjectToDateTime(object obj, DateTime defValue)
    {
        return Utils.StrToDateTime(obj.ToString(), defValue);
    }
    public static string[] SplitString(string strContent, string strSplit)
    {
        string[] result;
        if (!string.IsNullOrEmpty(strContent))
        {
            if (strContent.IndexOf(strSplit) < 0)
            {
                result = new string[]
					{
						strContent
					};
            }
            else
            {
                result = Regex.Split(strContent, Regex.Escape(strSplit), RegexOptions.IgnoreCase);
            }
        }
        else
        {
            result = new string[0];
        }
        return result;
    }
    public static string[] SplitString(string strContent, string strSplit, int count)
    {
        string[] result = new string[count];
        string[] splited = Utils.SplitString(strContent, strSplit);
        for (int i = 0; i < count; i++)
        {
            if (i < splited.Length)
            {
                result[i] = splited[i];
            }
            else
            {
                result[i] = string.Empty;
            }
        }
        return result;
    }
    public static string DelLastComma(string str)
    {
        return str.Substring(0, str.LastIndexOf(","));
    }
    public static string DelLastChar(string str, string strchar)
    {
        string result;
        if (string.IsNullOrEmpty(str))
        {
            result = "";
        }
        else
        {
            if (str.LastIndexOf(strchar) >= 0 && str.LastIndexOf(strchar) == str.Length - 1)
            {
                result = str.Substring(0, str.LastIndexOf(strchar));
            }
            else
            {
                result = str;
            }
        }
        return result;
    }
    public static string StringOfChar(int strLong, string str)
    {
        string ReturnStr = "";
        for (int i = 0; i < strLong; i++)
        {
            ReturnStr += str;
        }
        return ReturnStr;
    }
    public static string GetRamCode()
    {
        return DateTime.Now.ToString("yyyyMMddHHmmssffff");
    }
    public static string CutString(string inputString, int len)
    {
        string result;
        if (string.IsNullOrEmpty(inputString))
        {
            result = "";
        }
        else
        {
            inputString = Utils.DropHTML(inputString);
            ASCIIEncoding ascii = new ASCIIEncoding();
            int tempLen = 0;
            string tempString = "";
            byte[] s = ascii.GetBytes(inputString);
            for (int i = 0; i < s.Length; i++)
            {
                if (s[i] == 63)
                {
                    tempLen += 2;
                }
                else
                {
                    tempLen++;
                }
                try
                {
                    tempString += inputString.Substring(i, 1);
                }
                catch
                {
                    break;
                }
                if (tempLen > len)
                {
                    break;
                }
            }
            byte[] mybyte = Encoding.Default.GetBytes(inputString);
            if (mybyte.Length > len)
            {
                tempString += "…";
            }
            result = tempString;
        }
        return result;
    }
    public static string DropHTML(string Htmlstring)
    {
        string result;
        if (string.IsNullOrEmpty(Htmlstring))
        {
            result = "";
        }
        else
        {
            Htmlstring = Regex.Replace(Htmlstring, "<script[^>]*?>.*?</script>", "", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "<(.[^>]*)>", "", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "([\\r\\n])[\\s]+", "", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "-->", "", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "<!--.*", "", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(quot|#34);", "\"", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(amp|#38);", "&", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(lt|#60);", "<", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(gt|#62);", ">", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(nbsp|#160);", " ", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(iexcl|#161);", "¡", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(cent|#162);", "¢", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(pound|#163);", "£", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&(copy|#169);", "©", RegexOptions.IgnoreCase);
            Htmlstring = Regex.Replace(Htmlstring, "&#(\\d+);", "", RegexOptions.IgnoreCase);
            Htmlstring.Replace("<", "");
            Htmlstring.Replace(">", "");
            Htmlstring.Replace("\r\n", "");
            Htmlstring = HttpContext.Current.Server.HtmlEncode(Htmlstring).Trim();
            result = Htmlstring;
        }
        return result;
    }
    public static string DropHTML(string Htmlstring, int strLen)
    {
        return Utils.CutString(Utils.DropHTML(Htmlstring), strLen);
    }
    public static string ToHtml(string Input)
    {
        StringBuilder sb = new StringBuilder(Input);
        sb.Replace("&", "&amp;");
        sb.Replace("<", "&lt;");
        sb.Replace(">", "&gt;");
        sb.Replace("\r\n", "<br />");
        sb.Replace("\n", "<br />");
        sb.Replace("\t", " ");
        return sb.ToString();
    }
    public static string ToTxt(string Input)
    {
        StringBuilder sb = new StringBuilder(Input);
        sb.Replace("&nbsp;", " ");
        sb.Replace("<br>", "\r\n");
        sb.Replace("<br>", "\n");
        sb.Replace("<br />", "\n");
        sb.Replace("<br />", "\r\n");
        sb.Replace("&lt;", "<");
        sb.Replace("&gt;", ">");
        sb.Replace("&amp;", "&");
        return sb.ToString();
    }
    public static bool IsSafeSqlString(string str)
    {
        return !Regex.IsMatch(str, "[-|;|,|\\/|\\(|\\)|\\[|\\]|\\}|\\{|%|@|\\*|!|\\']");
    }
    public static string Filter(string sInput)
    {
        string result;
        if (sInput == null || sInput == "")
        {
            result = null;
        }
        else
        {
            string sInput2 = sInput.ToLower();
            string pattern = "*|and|exec|insert|select|delete|update|count|master|truncate|declare|char(|mid(|chr(|'";
            if (Regex.Match(sInput2, Regex.Escape(pattern), RegexOptions.IgnoreCase | RegexOptions.Compiled).Success)
            {
                throw new Exception("字符串中含有非法字符!");
            }
            string output = sInput.Replace("'", "''");
            result = output;
        }
        return result;
    }
    public static bool SqlFilter(string word, string InText)
    {
        bool result;
        if (InText == null)
        {
            result = false;
        }
        else
        {
            string[] array = word.Split(new char[]
				{
					'|'
				});
            for (int j = 0; j < array.Length; j++)
            {
                string i = array[j];
                if (InText.ToLower().IndexOf(i + " ") > -1 || InText.ToLower().IndexOf(" " + i) > -1)
                {
                    result = true;
                    return result;
                }
            }
            result = false;
        }
        return result;
    }
    public static string Htmls(string Input)
    {
        string result;
        if (Input != string.Empty && Input != null)
        {
            string ihtml = Input.ToLower();
            ihtml = ihtml.Replace("<script", "&lt;script");
            ihtml = ihtml.Replace("script>", "script&gt;");
            ihtml = ihtml.Replace("<%", "&lt;%");
            ihtml = ihtml.Replace("%>", "%&gt;");
            ihtml = ihtml.Replace("<$", "&lt;$");
            ihtml = ihtml.Replace("$>", "$&gt;");
            result = ihtml;
        }
        else
        {
            result = string.Empty;
        }
        return result;
    }
    public static bool IsIP(string ip)
    {
        return Regex.IsMatch(ip, "^((2[0-4]\\d|25[0-5]|[01]?\\d\\d?)\\.){3}(2[0-4]\\d|25[0-5]|[01]?\\d\\d?)$");
    }
    public static string GetMapPath(string strPath)
    {
        string result;
        if (strPath.ToLower().StartsWith("http://"))
        {
            result = strPath;
        }
        else
        {
            if (HttpContext.Current != null)
            {
                result = HttpContext.Current.Server.MapPath(strPath);
            }
            else
            {
                strPath = strPath.Replace("/", "\\");
                if (strPath.StartsWith("\\"))
                {
                    strPath = strPath.Substring(strPath.IndexOf('\\', 1)).TrimStart(new char[]
						{
							'\\'
						});
                }
                result = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, strPath);
            }
        }
        return result;
    }
    public static bool DeleteFile(string _filepath)
    {
        bool result;
        if (string.IsNullOrEmpty(_filepath))
        {
            result = false;
        }
        else
        {
            string fullpath = Utils.GetMapPath(_filepath);
            if (File.Exists(fullpath))
            {
                File.Delete(fullpath);
                result = true;
            }
            else
            {
                result = false;
            }
        }
        return result;
    }
    public static void DeleteUpFile(string _filepath)
    {
        if (!string.IsNullOrEmpty(_filepath))
        {
            string thumbnailpath = _filepath.Substring(0, _filepath.LastIndexOf("/")) + "mall_" + _filepath.Substring(_filepath.LastIndexOf("/") + 1);
            string fullTPATH = Utils.GetMapPath(_filepath);
            string fullpath = Utils.GetMapPath(_filepath);
            if (File.Exists(fullpath))
            {
                File.Delete(fullpath);
            }
            if (File.Exists(fullTPATH))
            {
                File.Delete(fullTPATH);
            }
        }
    }
    public static int GetFileSize(string _filepath)
    {
        int result;
        if (string.IsNullOrEmpty(_filepath))
        {
            result = 0;
        }
        else
        {
            string fullpath = Utils.GetMapPath(_filepath);
            if (File.Exists(fullpath))
            {
                FileInfo fileInfo = new FileInfo(fullpath);
                result = (int)fileInfo.Length / 1024;
            }
            else
            {
                result = 0;
            }
        }
        return result;
    }
    public static string GetFileExt(string _filepath)
    {
        string result;
        if (string.IsNullOrEmpty(_filepath))
        {
            result = "";
        }
        else
        {
            if (_filepath.LastIndexOf(".") > 0)
            {
                result = _filepath.Substring(_filepath.LastIndexOf(".") + 1);
            }
            else
            {
                result = "";
            }
        }
        return result;
    }
    public static void WriteCookie(string strName, string strValue)
    {
        HttpCookie cookie = HttpContext.Current.Request.Cookies[strName];
        if (cookie == null)
        {
            cookie = new HttpCookie(strName);
        }
        cookie.Value = Utils.UrlEncode(strValue);
        HttpContext.Current.Response.AppendCookie(cookie);
    }
    public static void WriteCookie(string strName, string key, string strValue)
    {
        HttpCookie cookie = HttpContext.Current.Request.Cookies[strName];
        if (cookie == null)
        {
            cookie = new HttpCookie(strName);
        }
        cookie[key] = Utils.UrlEncode(strValue);
        HttpContext.Current.Response.AppendCookie(cookie);
    }
    public static void WriteCookie(string strName, string key, string strValue, int expires)
    {
        HttpCookie cookie = HttpContext.Current.Request.Cookies[strName];
        if (cookie == null)
        {
            cookie = new HttpCookie(strName);
        }
        cookie[key] = Utils.UrlEncode(strValue);
        cookie.Expires = DateTime.Now.AddMinutes((double)expires);
        HttpContext.Current.Response.AppendCookie(cookie);
    }
    public static void WriteCookie(string strName, string strValue, int expires)
    {
        HttpCookie cookie = HttpContext.Current.Request.Cookies[strName];
        if (cookie == null)
        {
            cookie = new HttpCookie(strName);
        }
        cookie.Value = Utils.UrlEncode(strValue);
        cookie.Expires = DateTime.Now.AddMinutes((double)expires);
        HttpContext.Current.Response.AppendCookie(cookie);
    }
    public static string GetCookie(string strName)
    {
        string result;
        if (HttpContext.Current.Request.Cookies != null && HttpContext.Current.Request.Cookies[strName] != null)
        {
            result = Utils.UrlDecode(HttpContext.Current.Request.Cookies[strName].Value.ToString());
        }
        else
        {
            result = "";
        }
        return result;
    }
    public static string GetCookie(string strName, string key)
    {
        string result;
        if (HttpContext.Current.Request.Cookies != null && HttpContext.Current.Request.Cookies[strName] != null && HttpContext.Current.Request.Cookies[strName][key] != null)
        {
            result = Utils.UrlDecode(HttpContext.Current.Request.Cookies[strName][key].ToString());
        }
        else
        {
            result = "";
        }
        return result;
    }
    public static string ReplaceStr(string originalStr, string oldStr, string newStr)
    {
        string result;
        if (string.IsNullOrEmpty(oldStr))
        {
            result = "";
        }
        else
        {
            result = originalStr.Replace(oldStr, newStr);
        }
        return result;
    }
    ///   <summary> 
    ///   删除Cookies 
    ///   </summary> 
    ///   <param   name= "strName "> Cookie   主键 </param> 
    ///   <code> Cookie   ck   =   new   Cookie(); </code> 
    ///   <code> ck.delCookie( "主键 "); </code> 
    public static void delCookie(string strName)
    {
        try
        {
            HttpCookie Cookie = new HttpCookie(strName);
            Cookie.Expires = DateTime.Now.AddDays(-5);
            HttpContext.Current.Response.Cookies.Add(Cookie);
        }
        catch (Exception er)
        {
            throw er;
        }
    }
    public static string OutPageList(int pageSize, int pageIndex, int totalCount, string linkUrl, int centSize)
    {
        string result;
        if (totalCount < 1 || pageSize < 1)
        {
            result = "";
        }
        else
        {
            int pageCount = totalCount / pageSize;
            if (pageCount < 1)
            {
                result = "";
            }
            else
            {
                if (totalCount % pageSize > 0)
                {
                    pageCount++;
                }
                if (pageCount <= 1)
                {
                    result = "";
                }
                else
                {
                    StringBuilder pageStr = new StringBuilder();
                    string pageId = "__id__";
                    string firstBtn = "<a href=\"" + Utils.ReplaceStr(linkUrl, pageId, (pageIndex - 1).ToString()) + "\">«上一页</a>";
                    string lastBtn = "<a href=\"" + Utils.ReplaceStr(linkUrl, pageId, (pageIndex + 1).ToString()) + "\">下一页»</a>";
                    string firstStr = "<a href=\"" + Utils.ReplaceStr(linkUrl, pageId, "1") + "\">1</a>";
                    string lastStr = string.Concat(new string[]
						{
							"<a href=\"",
							Utils.ReplaceStr(linkUrl, pageId, pageCount.ToString()),
							"\">",
							pageCount.ToString(),
							"</a>"
						});
                    if (pageIndex <= 1)
                    {
                        firstBtn = "<span class=\"disabled\">«上一页</span>";
                    }
                    if (pageIndex >= pageCount)
                    {
                        lastBtn = "<span class=\"disabled\">下一页»</span>";
                    }
                    if (pageIndex == 1)
                    {
                        firstStr = "<span class=\"current\">1</span>";
                    }
                    if (pageIndex == pageCount)
                    {
                        lastStr = "<span class=\"current\">" + pageCount.ToString() + "</span>";
                    }
                    int firstNum = pageIndex - centSize / 2;
                    if (pageIndex < centSize)
                    {
                        firstNum = 2;
                    }
                    int lastNum = pageIndex + centSize - (centSize / 2 + 1);
                    if (lastNum >= pageCount)
                    {
                        lastNum = pageCount - 1;
                    }
                    pageStr.Append(firstBtn + firstStr);
                    if (pageIndex >= centSize)
                    {
                        pageStr.Append("<span>...</span>\n");
                    }
                    for (int i = firstNum; i <= lastNum; i++)
                    {
                        if (i == pageIndex)
                        {
                            pageStr.Append("<span class=\"current\">" + i + "</span>");
                        }
                        else
                        {
                            pageStr.Append(string.Concat(new object[]
								{
									"<a href=\"",
									Utils.ReplaceStr(linkUrl, pageId, i.ToString()),
									"\">",
									i,
									"</a>"
								}));
                        }
                    }
                    if (pageCount - pageIndex > centSize - centSize / 2)
                    {
                        pageStr.Append("<span>...</span>");
                    }
                    pageStr.Append(lastStr + lastBtn);
                    result = pageStr.ToString();
                }
            }
        }
        return result;
    }
    public static string UrlEncode(string str)
    {
        string result;
        if (string.IsNullOrEmpty(str))
        {
            result = "";
        }
        else
        {
            str = str.Replace("'", "");
            result = HttpContext.Current.Server.UrlEncode(str);
        }
        return result;
    }
    public static string UrlDecode(string str)
    {
        string result;
        if (string.IsNullOrEmpty(str))
        {
            result = "";
        }
        else
        {
            result = HttpContext.Current.Server.UrlDecode(str);
        }
        return result;
    }
    public static string CombUrlTxt(string _url, string _keys, params string[] _values)
    {
        StringBuilder urlParams = new StringBuilder();
        string result;
        try
        {
            string[] keyArr = _keys.Split(new char[]
				{
					'&'
				});
            for (int i = 0; i < keyArr.Length; i++)
            {
                if (!string.IsNullOrEmpty(_values[i]) && _values[i] != "0")
                {
                    _values[i] = Utils.UrlEncode(_values[i]);
                    urlParams.Append(string.Format(keyArr[i], _values) + "&");
                }
            }
            if (!string.IsNullOrEmpty(urlParams.ToString()) && _url.IndexOf("?") == -1)
            {
                urlParams.Insert(0, "?");
            }
        }
        catch
        {
            result = _url;
            return result;
        }
        result = _url + Utils.DelLastChar(urlParams.ToString(), "&");
        return result;
    }
}