﻿using System;
using System.Data;
using System.Data.OleDb;


/// <summary>
/// dataoperate 为用于对数据库进行操作的基类
/// 项目名称：企业网站通用后台管理系统
/// /// </summary>
public class dataoperate
{
    public static string constring = theconnectstring.constring;
    public OleDbConnection mycon = new OleDbConnection();                                            //OleDbConnection实例化对象 
    public dataoperate()
    {
        if (sqlchecker.checking())
        {
            if (mycon.State == ConnectionState.Open)
                mycon.Close();
        }
        else
        {
            mycon.ConnectionString = constring;
        }
    }


    //*****************************************************************
    //作用：打开数据库连接
    //参数：constring来自于webconfig的constring数据库连接字符串
    //返回值：无
    //*****************************************************************
    public void opencon()
    {
        mycon.Open();
    }


    //*****************************************************************
    //作用：关闭数据库连接
    //参数：constring来自于webconfig的constring数据库连接字符串
    //返回值：无
    //*****************************************************************
    public void closecon()
    {
        mycon.Close();
    }

    public void editfooter(string footerinfo)
    {
        OleDbCommand mycmd = new OleDbCommand("editthefooterinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@info", footerinfo);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加网站新闻类型
    //参数：group_name新闻类型名称
    //返回值：无
    //*****************************************************************
    public void addnewsgroup(string group_name)
    {
        OleDbCommand mycmd = new OleDbCommand("addnewsgroup", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@group_name", group_name);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：删除网站新闻类型
    //参数：id
    //返回值：无
    //*****************************************************************
    public void delnewsgroup(int id)
    {
        OleDbCommand mycmd = new OleDbCommand("delnewsgroup", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：修改网站新闻类型
    //参数：id
    //返回值：无
    //*****************************************************************
    public void editnewsgroup(int id, string groupname)
    {
        OleDbCommand mycmd = new OleDbCommand("editnewsgroup", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@id", id);
        mycmd.Parameters.Add("@groupname", groupname);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加网站常用栏目
    //参数：group_name栏目名称
    //返回值：无
    //*****************************************************************
    public void addgroup(string group_name, string pages)
    {
        OleDbCommand mycmd = new OleDbCommand("addgroup", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@group_name", group_name);
        mycmd.Parameters.Add("@pages", pages);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：修改网站常用栏目
    //参数：group_name新栏目名称 group_id栏目id
    //返回值：无
    //*****************************************************************
    public void editgroup(int group_id, string group_name, string pages)
    {
        OleDbCommand mycmd = new OleDbCommand("editgroup", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@group_name", group_name);
        mycmd.Parameters.Add("@pages", pages);
        mycmd.Parameters.Add("@group_id", group_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加网站栏目具体信息
    //参数：group_area信息内容 group_id栏目id AddedDate信息发布时间
    //返回值：无
    //*****************************************************************
    public void addnews(int news_group, string news_title, string comefrom, string content, DateTime AddedDate, string news_pic, string flag, string commarea)
    {
        OleDbCommand mycmd = new OleDbCommand("addnews", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@news_group", news_group);
        mycmd.Parameters.Add("@news_title", news_title);
        mycmd.Parameters.Add("@comefrom", comefrom);
        mycmd.Parameters.Add("@content", content);
        mycmd.Parameters.Add("@AddedDate", AddedDate);
        mycmd.Parameters.Add("@news_pic", news_pic);
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@commarea", commarea);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：修改网站栏目具体信息
    //参数：group_area信息内容; group_id栏目id; AddedDate信息发布时间 ; news_id信息编号
    //返回值：无
    //*****************************************************************
    public void editnews(int news_id, int news_group, string news_title, string comefrom, string content, DateTime AddedDate, string news_pic, string flag, string commarea)
    {
        OleDbCommand mycmd = new OleDbCommand("editnews", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add(new OleDbParameter("@newsgroup", news_group));
        mycmd.Parameters.Add(new OleDbParameter("@newstitle", news_title));
        mycmd.Parameters.Add(new OleDbParameter("@comefrom", comefrom));
        mycmd.Parameters.Add(new OleDbParameter("@newsuptime", AddedDate));
        mycmd.Parameters.Add(new OleDbParameter("@newspic", news_pic));
        mycmd.Parameters.Add(new OleDbParameter("@newsarea", content));
        mycmd.Parameters.Add(new OleDbParameter("@flag", flag));
        mycmd.Parameters.Add(new OleDbParameter("@commarea", commarea));
        mycmd.Parameters.Add(new OleDbParameter("@newsid", news_id));
        mycon.Open();
        try
        {
            mycmd.ExecuteNonQuery();
        }
        catch { }
        mycon.Close();
    }

    //*****************************************************************
    //作用：删除网站栏目具体信息
    //参数： news_id信息编号
    //返回值：无
    //*****************************************************************
    public void delnews(int news_id)
    {
        OleDbCommand mycmd = new OleDbCommand("delnews", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@news_id", news_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：添加省市内容
    //参数：city_name省市名称;theindex省份中的排列位置
    //返回值：无
    //*****************************************************************
    public void addcity(string city_name, int theindex)
    {
        OleDbCommand mycmd = new OleDbCommand("addcity", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@city_name", city_name);
        mycmd.Parameters.Add("@theindex", theindex);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：修改省市内容
    //参数：city_name省市名称;theindex省份中的排列位置;city_id要修改的省市id
    //返回值：无
    //*****************************************************************
    public void editcity(string city_name, int theindex, int city_id)
    {
        OleDbCommand mycmd = new OleDbCommand("editcity", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@city_name", city_name);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@city_id", city_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：删除省市内容
    //参数：city_id要删除的省市id
    //返回值：无
    //*****************************************************************
    public void delcity(int city_id)
    {
        OleDbCommand mycmd = new OleDbCommand("delcity", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@city_id", city_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加营销网络信息
    //参数：city_id为所属省市id;con_tel联系电话;con_pcphone手机;con_addr:地址;thearea备注性描述;theindex:排序参数
    //      con_pepole联系人
    //返回值：无
    //*****************************************************************
    public void addyxnet(int city_id, string con_pepole, string con_tel, string con_pcphone, string con_addr, string thearea, int theindex)
    {
        OleDbCommand mycmd = new OleDbCommand("addyxnet", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@city_id", city_id);
        mycmd.Parameters.Add("@con_pepole", con_pepole);
        mycmd.Parameters.Add("@con_tel", con_tel);
        mycmd.Parameters.Add("@con_pcphone", con_pcphone);
        mycmd.Parameters.Add("@con_addr", con_addr);
        mycmd.Parameters.Add("@thearea", thearea);
        mycmd.Parameters.Add("@theindex", theindex);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：修改营销网络信息
    //参数：id:要修改信息编号;city_id为所属省市id;con_tel联系电话;con_pcphone手机;con_addr:地址;thearea备注性描述;theindex:排序参数
    //      con_pepole联系人
    //返回值：无
    //*****************************************************************
    public void edityxnet(int id, int city_id, string con_pepole, string con_tel, string con_pcphone, string con_addr, string thearea, int theindex)
    {
        OleDbCommand mycmd = new OleDbCommand("edityxnet", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@city_id", city_id);
        mycmd.Parameters.Add("@con_pepole", con_pepole);
        mycmd.Parameters.Add("@con_tel", con_tel);
        mycmd.Parameters.Add("@con_pcphone", con_pcphone);
        mycmd.Parameters.Add("@con_addr", con_addr);
        mycmd.Parameters.Add("@thearea", thearea);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：删除营销网络信息
    //参数：id:删除信息编号;
    //返回值：无
    //*****************************************************************
    public void delyxnet(int id)
    {
        OleDbCommand mycmd = new OleDbCommand("delyxnet", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加客户反馈信息
    //参数：reptitle主题 reparea具体内容 conpepole联系人 confox传真 conemail邮箱 conpcphone手机 conyb邮编 conaddr地址 concompany公司 flag查看标字 reptime发布时间
    //返回值：无
    //*****************************************************************
    public void addrepinfo(string rep_title, string rep_area, string con_pepole, string con_fox, string con_email, string con_pcphone, string con_yb, string con_addr, string con_company, string flag, DateTime reptime, string contel)
    {
        OleDbCommand mycmd = new OleDbCommand("addrepinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@rep_title", rep_title);
        mycmd.Parameters.Add("@rep_area", rep_area);
        mycmd.Parameters.Add("@con_pepole", con_pepole);
        mycmd.Parameters.Add("@con_fox", con_fox);
        mycmd.Parameters.Add("@con_email", con_email);
        mycmd.Parameters.Add("@con_pcphone", con_pcphone);
        mycmd.Parameters.Add("@con_yb", con_yb);
        mycmd.Parameters.Add("@con_addr", con_addr);
        mycmd.Parameters.Add("@con_company", con_company);
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@reptime", Convert.ToDateTime(reptime.Date.ToString()));
        mycmd.Parameters.Add("@contel", contel);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：删除客户反馈信息
    //参数：rep_id要删除编号
    //返回值：无
    //*****************************************************************
    public void delrepinfo(int rep_id)
    {
        OleDbCommand mycmd = new OleDbCommand("delrepinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@rep_id", rep_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }



    //*****************************************************************
    //作用：根据city_id返回city_name
    //参数：city_id省市编号
    //返回值：无
    //*****************************************************************
    public string selcityname(int city_id)
    {
        OleDbCommand mycmd = new OleDbCommand("selcityname", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@city_id", city_id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        myreader.Read();
        string cityname = myreader["city_name"].ToString();
        myreader.Close();
        mycon.Close();
        return cityname;
    }


    //*****************************************************************
    //作用：根据rep_id返回留言信息
    //参数：rep_id留言编号
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selrepinfo(int rep_id)
    {
        OleDbCommand mycmd = new OleDbCommand("selrepinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@rep_id", rep_id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }



    //*****************************************************************
    //作用：根据rep_id修改阅读状态为已阅
    //参数：rep_id留言编号
    //返回值：无
    //*****************************************************************
    public void changeflag(int rep_id)
    {
        OleDbCommand mycmd = new OleDbCommand("changeflag", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@rep_id", rep_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：根据rep_id修改阅读状态为已阅
    //参数：rep_id留言编号
    //返回值：无
    //*****************************************************************
    public void changeflag1(int order_id)
    {
        OleDbCommand mycmd = new OleDbCommand("changeflag1", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@order_id", order_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }



    //*****************************************************************
    //作用：根据order_id删除相应订单信息
    //参数：order_id留言编号
    //返回值：无
    //*****************************************************************
    public void delorderinfo(int order_id)
    {
        OleDbCommand mycmd = new OleDbCommand("delorderinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@order_id", order_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：反回版权信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selfooterinfo()
    {
        OleDbCommand mycmd = new OleDbCommand("selfooterinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }


    //*****************************************************************
    //作用：添加分类信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public void addproductcss(int parent_id, int flag, string thename, string info1, string info2, int theindex, string smallpic, string bigpic, string area)
    {
        OleDbCommand mycmd = new OleDbCommand("addprotuct", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@parent_id", parent_id);
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@thename", thename);
        mycmd.Parameters.Add("@xinhao", info1);
        mycmd.Parameters.Add("@guige", info2);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@smallpic", smallpic);
        mycmd.Parameters.Add("@bigpic", bigpic);
        mycmd.Parameters.Add("@thearea", area);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加产品信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public void addproductinfo(int class_id, string thename, string info1, string info2, string guige, string xinhao, int theindex, string smallpic, string bigpic, string area, int flag)
    {
        OleDbCommand mycmd = new OleDbCommand("addproductinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@class_id", class_id);
        mycmd.Parameters.Add("@thename", thename);
        mycmd.Parameters.Add("@info1", info1);
        mycmd.Parameters.Add("@info2", info2);
        mycmd.Parameters.Add("@guige", guige);
        mycmd.Parameters.Add("@xinhao", xinhao);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@smallpic", smallpic);
        mycmd.Parameters.Add("@bigpic", bigpic);
        mycmd.Parameters.Add("@thearea", area);
        mycmd.Parameters.Add("@flag", flag);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }
    //*****************************************************************
    //作用：修改分类信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public void editproductcss(int flag, string thename, string info1, string info2, string smallpic, string bigpic, string thearea, int theindex, int self_id)
    {
        OleDbCommand mycmd = new OleDbCommand("editproduct", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@thename", thename);
        mycmd.Parameters.Add("@info1", info1);
        mycmd.Parameters.Add("@info2", info2);
        mycmd.Parameters.Add("@smallpic", smallpic);
        mycmd.Parameters.Add("@bigpic", bigpic);
        mycmd.Parameters.Add("@thearea", thearea);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@self_id", self_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：修改修改产品信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public void editproductdetail(int self_id, int class_id, string thename, string info1, string info2, string guige, string xinhao, int theindex, string smallpic, string bigpic, string area)
    {
        OleDbCommand mycmd = new OleDbCommand("editproductdetail", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@class_id", class_id);
        mycmd.Parameters.Add("@thename", thename);
        mycmd.Parameters.Add("@info1", info1);
        mycmd.Parameters.Add("@info2", info2);
        mycmd.Parameters.Add("@guige", guige);
        mycmd.Parameters.Add("@xinhao", xinhao);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@smallpic", smallpic);
        mycmd.Parameters.Add("@bigpic", bigpic);
        mycmd.Parameters.Add("@thearea", area);
        mycmd.Parameters.Add("@self_id", self_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：删除分类信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public void delproduct(int self_id)
    {
        OleDbCommand mycmd = new OleDbCommand("deletesomesubguige", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@self_id", self_id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycmd.CommandText = "deletesomeguige";
        mycmd.Parameters.Add("@self_id", self_id);
        mycmd.ExecuteNonQuery();
        mycmd.CommandText = "delproduct1";
        mycmd.Parameters.Add("@self_id", self_id);
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：反回顶层分类信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public OleDbDataReader returnbaseclass()
    {
        OleDbCommand mycmd = new OleDbCommand("returnbaseclass", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }


    //*****************************************************************
    //作用：反回分类信息详细信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public OleDbDataReader returnproductclassinfo(int self_id)
    {
        OleDbCommand mycmd = new OleDbCommand("returnproductclassinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@self_id", self_id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }

    //*****************************************************************
    //作用：发布招聘信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public void addhrinfo(string jobname, string jobleixin, string jobaddr, int zhaopingnum, string xueli, string age, string jingyan, string sex, string daiyu, string gangwei, string other, DateTime starttime, DateTime endtime, string mianshiyaoqiou)
    {
        OleDbCommand mycmd = new OleDbCommand("addhrinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@jobname", jobname);
        mycmd.Parameters.Add("@jobleixin", jobleixin);
        mycmd.Parameters.Add("@jobaddr", jobaddr);
        mycmd.Parameters.Add("@zhaopingnum", zhaopingnum);
        mycmd.Parameters.Add("@xueli", xueli);
        mycmd.Parameters.Add("@age", age);
        mycmd.Parameters.Add("@jingyan", jingyan);
        mycmd.Parameters.Add("@sex", sex);
        mycmd.Parameters.Add("@daiyu", daiyu);
        mycmd.Parameters.Add("@gangwei", gangwei);
        mycmd.Parameters.Add("@other", other);
        mycmd.Parameters.Add("@starttime", starttime);
        mycmd.Parameters.Add("@endtime", endtime);
        mycmd.Parameters.Add("@mianshiyaoqiou", mianshiyaoqiou);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }
    //*****************************************************************
    //作用：修改招聘信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public void edithrinfo(int id, string jobname, string jobleixin, string jobaddr, int zhaopingnum, string xueli, string age, string jingyan, string sex, string daiyu, string gangwei, string other, DateTime starttime, DateTime endtime, string mianshiyaoqiou)
    {
        OleDbCommand mycmd = new OleDbCommand("edithrinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@jobname", jobname);
        mycmd.Parameters.Add("@jobleixin", jobleixin);
        mycmd.Parameters.Add("@jobaddr", jobaddr);
        mycmd.Parameters.Add("@zhaopingnum", zhaopingnum);
        mycmd.Parameters.Add("@xueli", xueli);
        mycmd.Parameters.Add("@age", age);
        mycmd.Parameters.Add("@jingyan", jingyan);
        mycmd.Parameters.Add("@sex", sex);
        mycmd.Parameters.Add("@daiyu", daiyu);
        mycmd.Parameters.Add("@gangwei", gangwei);
        mycmd.Parameters.Add("@other", other);
        mycmd.Parameters.Add("@starttime", starttime);
        mycmd.Parameters.Add("@endtime", endtime);
        mycmd.Parameters.Add("@mianshiyaoqiou", mianshiyaoqiou);
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：反回栏目信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public  string returnnanmuinfo(string type)
    {
        string x;
        OleDbCommand mycmd = new OleDbCommand("selnanmuinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@type", type);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        if (myreader.HasRows)
        {
            myreader.Read();
            x = myreader["area"].ToString();
        }
        else
            x = "暂无";
        myreader.Close();
        mycon.Close();
        return x;
    }


    //*****************************************************************
    //作用：反回产品基本信息 名称，小图，编号
    //参数：无
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selproductcommoninfo(int class_id)
    {
        OleDbCommand mycmd = new OleDbCommand("selproductcommoninfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@class_id", class_id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }



    //*****************************************************************
    //作用：反回行政权信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public string returnfooterinfo()
    {
        string x;
        OleDbCommand mycmd = new OleDbCommand("select * from footer", mycon);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        if (myreader.HasRows)
        {
            myreader.Read();
            x = myreader["footerarea"].ToString();
        }
        else
            x = "暂无";
        myreader.Close();
        mycon.Close();
        return x;
    }


    //*****************************************************************
    //作用：反回产品分类信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selproductclasstop10()
    {
        OleDbCommand mycmd = new OleDbCommand("select top 10 self_id,thename,smallpic from productclass where parent_id=0 order by theindex ", mycon);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }

    //*****************************************************************
    //作用：反回产品分类信息
    //参数：无
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selproductclasstop()
    {
        OleDbCommand mycmd = new OleDbCommand("select  self_id,thename,smallpic from productclass where parent_id=0 order by theindex ", mycon);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }


    //*****************************************************************
    //作用：反回资质荣誉信息详细信息
    //参数：id编号
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selrongyu(int id)
    {
        OleDbCommand mycmd = new OleDbCommand("selrongyu", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }



    //*****************************************************************
    //作用：反回资质荣誉信息详细信息
    //参数：id编号
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selrongyu1()
    {
        OleDbCommand mycmd = new OleDbCommand("selrongyu1", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }


    //*****************************************************************
    //作用：添加企业荣誉信息
    //参数：相关
    //返回值：无
    //*****************************************************************
    public void addrongyu(string smallpic, string bigpic, int theindex, string thename, string area)
    {
        OleDbCommand mycmd = new OleDbCommand("addrongyu", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@smallpic", smallpic);
        mycmd.Parameters.Add("@bigpic", bigpic);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@thename", thename);
        mycmd.Parameters.Add("@area", area);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：修改企业荣誉信息
    //参数：相关
    //返回值：无
    //*****************************************************************
    public void editrongyu(int id, string smallpic, string bigpic, int theindex, string thename, string area)
    {
        OleDbCommand mycmd = new OleDbCommand("editrongyu", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@smallpic", smallpic);
        mycmd.Parameters.Add("@bigpic", bigpic);
        mycmd.Parameters.Add("@theindex", theindex);
        mycmd.Parameters.Add("@thename", thename);
        mycmd.Parameters.Add("@area", area);
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加订单信息
    //参数：相关
    //返回值：无
    //*****************************************************************
    public void addorderinfo(string product_name, int sulian, string con_company, string con_pepole, string con_tel, string con_fox, string con_pcphone, string con_email, string con_addr, string con_yb, string con_qq, string area, string flag, DateTime order_time)
    {
        OleDbCommand mycmd = new OleDbCommand("addorder", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@product_name", product_name);
        mycmd.Parameters.Add("@sulian", sulian);
        mycmd.Parameters.Add("@con_company", con_company);
        mycmd.Parameters.Add("@con_pepole", con_pepole);
        mycmd.Parameters.Add("@con_tel", con_tel);
        mycmd.Parameters.Add("@con_pcphone", con_pcphone);
        mycmd.Parameters.Add("@con_email", con_email);
        mycmd.Parameters.Add("@con_addr", con_addr);
        mycmd.Parameters.Add("@con_yb", con_yb);
        mycmd.Parameters.Add("@con_qq", con_qq);
        mycmd.Parameters.Add("@area", area);
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@con_fox", con_fox);
        mycmd.Parameters.Add("@order_time", Convert.ToDateTime(order_time.Date.ToString()));
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加订单信息
    //参数：相关
    //返回值：无
    //*****************************************************************
    public void addsample(string product_name, int sulian, string con_company, string con_pepole, string con_tel, string con_fox, string con_pcphone, string con_email, string con_addr, string con_yb, string con_qq, string area, string flag, DateTime order_time)
    {
        OleDbCommand mycmd = new OleDbCommand("addsample", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@product_name", product_name);
        mycmd.Parameters.Add("@sulian", sulian);
        mycmd.Parameters.Add("@con_company", con_company);
        mycmd.Parameters.Add("@con_pepole", con_pepole);
        mycmd.Parameters.Add("@con_tel", con_tel);
        mycmd.Parameters.Add("@con_pcphone", con_pcphone);
        mycmd.Parameters.Add("@con_email", con_email);
        mycmd.Parameters.Add("@con_addr", con_addr);
        mycmd.Parameters.Add("@con_yb", con_yb);
        mycmd.Parameters.Add("@con_qq", con_qq);
        mycmd.Parameters.Add("@area", area);
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@con_fox", con_fox);
        mycmd.Parameters.Add("@order_time", Convert.ToDateTime(order_time.Date.ToString()));
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：添加订单信息
    //参数：相关
    //返回值：无
    //*****************************************************************
    public void addbaojia(string product_name, int sulian, string con_company, string con_pepole, string con_tel, string con_fox, string con_pcphone, string con_email, string con_addr, string con_yb, string con_qq, string area, string flag, DateTime order_time)
    {
        OleDbCommand mycmd = new OleDbCommand("addbaojia", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@product_name", product_name);
        mycmd.Parameters.Add("@sulian", sulian);
        mycmd.Parameters.Add("@con_company", con_company);
        mycmd.Parameters.Add("@con_pepole", con_pepole);
        mycmd.Parameters.Add("@con_tel", con_tel);
        mycmd.Parameters.Add("@con_pcphone", con_pcphone);
        mycmd.Parameters.Add("@con_email", con_email);
        mycmd.Parameters.Add("@con_addr", con_addr);
        mycmd.Parameters.Add("@con_yb", con_yb);
        mycmd.Parameters.Add("@con_qq", con_qq);
        mycmd.Parameters.Add("@area", area);
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@con_fox", con_fox);
        mycmd.Parameters.Add("@order_time", Convert.ToDateTime(order_time.Date.ToString()));
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }





    //*****************************************************************
    //作用：添加订单信息
    //参数：相关
    //返回值：无
    //*****************************************************************
    public void addtuzi(string product_name, int sulian, string con_company, string con_pepole, string con_tel, string con_fox, string con_pcphone, string con_email, string con_addr, string con_yb, string con_qq, string area, string flag, DateTime order_time)
    {
        OleDbCommand mycmd = new OleDbCommand("addtuzi", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@product_name", product_name);
        mycmd.Parameters.Add("@sulian", sulian);
        mycmd.Parameters.Add("@con_company", con_company);
        mycmd.Parameters.Add("@con_pepole", con_pepole);
        mycmd.Parameters.Add("@con_tel", con_tel);
        mycmd.Parameters.Add("@con_pcphone", con_pcphone);
        mycmd.Parameters.Add("@con_email", con_email);
        mycmd.Parameters.Add("@con_addr", con_addr);
        mycmd.Parameters.Add("@con_yb", con_yb);
        mycmd.Parameters.Add("@con_qq", con_qq);
        mycmd.Parameters.Add("@area", area);
        mycmd.Parameters.Add("@flag", flag);
        mycmd.Parameters.Add("@con_fox", con_fox);
        mycmd.Parameters.Add("@order_time", Convert.ToDateTime(order_time.Date.ToString()));
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }

    //*****************************************************************
    //作用：反回荣誉条数
    //参数：无
    //返回值：无
    //*****************************************************************
    public int countrongyu()
    {
        int x = 0;
        OleDbCommand mycmd = new OleDbCommand("countrongyu", mycon);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        if (myreader.HasRows)
        {
            myreader.Read();
            x = Convert.ToInt32(myreader["n"].ToString());
        }
        myreader.Close();
        mycon.Close();
        return x;
    }



    //*****************************************************************
    //作用：反回营销网络一条具体信息
    //参数：id编号
    //返回值：无
    //*****************************************************************
    public OleDbDataReader returnyxnetinfo(int id)
    {
        OleDbCommand mycmd = new OleDbCommand("returnyxnetinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@city_id", id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }


    //*****************************************************************
    //作用：反回一条产品具体信息
    //参数：id编号
    //返回值：无
    //*****************************************************************
    public OleDbDataReader selproductinfodetail(int id)
    {
        OleDbCommand mycmd = new OleDbCommand("selproductinfodetail", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }



    //*****************************************************************
    //作用：反回一条新闻信息
    //参数：id编号
    //返回值：无
    //*****************************************************************
    public OleDbDataReader returnnews(int id)
    {
        OleDbCommand mycmd = new OleDbCommand("returnnews", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@id", id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }

    //*****************************************************************
    //作用：反回营销网络信息
    //参数：省市信息
    //返回值：无
    //*****************************************************************
    public OleDbDataReader returnyxnetbycityname(string city)
    {
        OleDbCommand mycmd = new OleDbCommand("returnyxnetbycityname", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@cityname", city);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;

    }


    //*****************************************************************
    //作用：分页反回资质荣誉信息
    //参数：省市信息
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="needpage">要反回的页</param>
    /// <param name="pagesize">每页记录条数</param>
    /// <returns></returns>
    public OleDbDataReader rongyupager(int needpage, int pagesize)
    {
        OleDbCommand mycmd = new OleDbCommand("rongyupager", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@needpage", needpage);
        mycmd.Parameters.Add("@pagesize", pagesize);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }


    //*****************************************************************
    //作用：分页反回资质荣誉信息
    //参数：省市信息
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="newstype">新闻类型</param>
    /// <returns></returns>
    public OleDbDataReader returnnewslist(string newstype)
    {
        OleDbCommand mycmd = new OleDbCommand("returnnewslist", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@newstype", newstype);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }





    //*****************************************************************
    //作用：反回用户查找信息
    //参数：查找关键字
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="@searchkey">查找关键字</param>
    /// <returns></returns>
    public OleDbDataReader searchproductbyuserkey(string searchkey)
    {
        OleDbCommand mycmd = new OleDbCommand("searchproductbyuserkey", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@searchkey", searchkey);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        return myreader;
    }
    //*****************************************************************
    //作用：反回一种类型的产品有多少个
    //参数：产品类型编号
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="@class_id">主品类型码</param>
    /// <returns></returns> 
    /// 
    public int countproductoftype(int class_id)
    {
        int reccount = 0;
        OleDbCommand mycmd = new OleDbCommand("countproductoftype", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@class_id", class_id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        if (myreader.HasRows)
        {
            myreader.Read();
            reccount = Convert.ToInt32(myreader["cnt"].ToString());
        }
        myreader.Close();
        mycon.Close();
        return reccount;
    }


    //*****************************************************************
    //作用：反回一种类型的产品有多少个
    //参数：产品类型编号
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="@class_id">主品类型码</param>
    /// <returns></returns> 
    /// 
    public int countproductclassoftype(int class_id)
    {
        int reccount = 0;
        OleDbCommand mycmd = new OleDbCommand("countproductclassoftype", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@parent_id", class_id);
        mycon.Open();
        OleDbDataReader myreader = mycmd.ExecuteReader();
        if (myreader.HasRows)
        {
            myreader.Read();
            reccount = Convert.ToInt32(myreader["cnt"].ToString());
        }
        myreader.Close();
        mycon.Close();
        return reccount;
    }



    //*****************************************************************
    //作用：添加栏目信息内容
    //参数：相关内容
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="@groupid">栏目类型码</param>
    /// <param name="@area">栏目内容</param>
    /// <returns></returns> 
    /// 
    public void addnanmuinfo(int groupid, string area)
    {
        int reccount = 0;
        OleDbCommand mycmd = new OleDbCommand("addnanmuinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@group_id", groupid);
        mycmd.Parameters.Add("@area", area);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }


    //*****************************************************************
    //作用：修改栏目信息内容
    //参数：相关内容
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="@groupid">栏目类型码</param>
    /// <param name="@area">栏目内容</param>
    /// <param name="@id">自身编号</param>
    /// <returns></returns> 
    /// 
    public void editnanmuinfo(int groupid, string area)
    {
        int reccount = 0;
        OleDbCommand mycmd = new OleDbCommand("editnanmuinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@area", area);
        mycmd.Parameters.Add("@group_id", groupid);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }





    //*****************************************************************
    //作用：添加应聘人员信息
    //参数：相关内容
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="thename">姓名</param>
    /// <param name="sex">性别</param>
    /// <param name="brtday">生日</param>
    /// <param name="minzu">民族</param>
    /// <param name="senggao">身高</param>
    /// <param name="dangtuan">党团</param>
    /// <param name="english">英语程度</param>
    /// <param name="senti">身体</param>
    /// <param name="jinyan">经验</param>
    /// <param name="geyan">格言</param>
    /// <param name="gongzi">工资要求</param>
    /// <param name="cizu">吃住要求</param>
    /// <param name="gangwei">岗位</param>
    /// <param name="sch">毕业院校</param>
    /// <param name="haddr">家底住址</param>
    /// <param name="yzcode">邮政编码</param>
    /// <param name="naddr">住址</param>
    /// <param name="tel">电话</param>
    /// <param name="fox">传真</param>
    /// <param name="qq">qq</param>
    /// <param name="infocomefrom">信息来源</param>
    /// <param name="uptime">时间</param>
    /// <param name="area">备注</param>
    /// <returns></returns> 
    /// 
    public void addworderinfo(string thename, string sex, DateTime brtday, string minzu, string senggao, string dangtuan, string english, string senti, string jinyan, string geyan, string gongzi, string cizu, string gangweimc, string sch, string haddr, string yzcode, string naddr, string tel, string fox, string qq, string infocimefrom, DateTime uptime, string area)
    {
        OleDbCommand mycmd = new OleDbCommand("addworkerinfo", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@thename", thename);
        mycmd.Parameters.Add("@sex", sex);
        mycmd.Parameters.Add("@brtday", brtday);
        mycmd.Parameters.Add("@minzu", minzu);
        mycmd.Parameters.Add("@senggao", senggao);
        mycmd.Parameters.Add("@dangtuan", dangtuan);
        mycmd.Parameters.Add("@english", english);
        mycmd.Parameters.Add("@senti", senti);
        mycmd.Parameters.Add("@jinyan", jinyan);
        mycmd.Parameters.Add("@geyan", geyan);
        mycmd.Parameters.Add("@gongzi", gongzi);
        mycmd.Parameters.Add("@cizu", cizu);
        mycmd.Parameters.Add("@gangweimc", gangweimc);
        mycmd.Parameters.Add("@sch", sch);
        mycmd.Parameters.Add("@haddr", haddr);
        mycmd.Parameters.Add("@yzcode", yzcode);
        mycmd.Parameters.Add("@naddr", naddr);
        mycmd.Parameters.Add("@tel", tel);
        mycmd.Parameters.Add("@fox", fox);
        mycmd.Parameters.Add("@qq", qq);
        mycmd.Parameters.Add("@infocomefrom", infocimefrom);
        mycmd.Parameters.Add("@uptime", uptime);
        mycmd.Parameters.Add("@area", area);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }



    //*****************************************************************
    //作用：添加会员
    //参数：相关内容
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="thename">姓名</param>
    /// <param name="sex">性别</param>
    /// <param name="brtday">生日</param>
    /// <param name="minzu">民族</param>
    /// <param name="senggao">身高</param>
    /// <param name="dangtuan">党团</param>
    /// <param name="english">英语程度</param>
    /// <param name="senti">身体</param>
    /// <param name="jinyan">经验</param>
    /// <param name="geyan">格言</param>
    /// <param name="gongzi">工资要求</param>
    /// <param name="cizu">吃住要求</param>
    /// <param name="gangwei">岗位</param>
    /// <param name="sch">毕业院校</param>
    /// <param name="haddr">家底住址</param>
    /// <param name="yzcode">邮政编码</param>
    /// <param name="naddr">住址</param>
    /// <param name="tel">电话</param>
    /// <param name="fox">传真</param>
    /// <param name="qq">qq</param>
    /// <param name="infocomefrom">信息来源</param>
    /// <param name="uptime">时间</param>
    /// <param name="area">备注</param>
    /// <returns></returns> 
    /// 
    public void addhuiyuan(string logoname, string pwd, string rname, string sex, string age, string company, string tel, string fax, string pcphone, string email, string yb, string qq, string addr, DateTime addtime, string question, string answer)
    {
        //        INSERT INTO huiyuan ( logoname, pwd, rname, sex, age, company, tel, fax, pcphone, email, yb, qq, addr, addtime, question, answer )
        //VALUES ([?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?]);


        OleDbCommand mycmd = new OleDbCommand("addhuiyuan", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("@logoname", logoname);
        mycmd.Parameters.Add("@pwd", pwd);
        mycmd.Parameters.Add("@rname", rname);
        mycmd.Parameters.Add("@sex", sex);
        mycmd.Parameters.Add("@age", age);
        mycmd.Parameters.Add("@company", company);
        mycmd.Parameters.Add("@tel", tel);
        mycmd.Parameters.Add("@fax", fax);
        mycmd.Parameters.Add("@pcphone", pcphone);
        mycmd.Parameters.Add("@email", email);
        mycmd.Parameters.Add("@yb", yb);
        mycmd.Parameters.Add("@qq", qq);
        mycmd.Parameters.Add("@addr", addr);
        mycmd.Parameters.Add("@addtime", DateTime.Now.Date.ToString());
        mycmd.Parameters.Add("@question", question);
        mycmd.Parameters.Add("@answer", answer);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }



    //*****************************************************************
    //作用：修改会员
    //参数：相关内容
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// </summary>
    /// <param name="thename">姓名</param>
    /// <param name="sex">性别</param>
    /// <param name="brtday">生日</param>
    /// <param name="minzu">民族</param>
    /// <param name="senggao">身高</param>
    /// <param name="dangtuan">党团</param>
    /// <param name="english">英语程度</param>
    /// <param name="senti">身体</param>
    /// <param name="jinyan">经验</param>
    /// <param name="geyan">格言</param>
    /// <param name="gongzi">工资要求</param>
    /// <param name="cizu">吃住要求</param>
    /// <param name="gangwei">岗位</param>
    /// <param name="sch">毕业院校</param>
    /// <param name="haddr">家底住址</param>
    /// <param name="yzcode">邮政编码</param>
    /// <param name="naddr">住址</param>
    /// <param name="tel">电话</param>
    /// <param name="fox">传真</param>
    /// <param name="qq">qq</param>
    /// <param name="infocomefrom">信息来源</param>
    /// <param name="uptime">时间</param>
    /// <param name="area">备注</param>
    /// <returns></returns> 
    /// 
    public void edithuiyuan(string logoname, string pwd, string rname, string sex, string age, string company, string tel, string fax, string pcphone, string email, string yb, string qq, string addr, DateTime addtime, string question, string answer, int id)
    {

        //        INSERT INTO huiyuan ( logoname, pwd, rname, sex, age,company, tel, fax, pcphone, email, yb, qq, addr, addtime, question, answer )
        //VALUES ([?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?], [?]);
        OleDbCommand mycmd = new OleDbCommand("edithuiyuan", mycon);
        mycmd.CommandType = CommandType.StoredProcedure;
        mycmd.Parameters.Add("logoname", logoname);
        mycmd.Parameters.Add("pwd", pwd);
        mycmd.Parameters.Add("rname", rname);
        mycmd.Parameters.Add("sex", sex);
        mycmd.Parameters.Add("age", age);
        mycmd.Parameters.Add("company", company);
        mycmd.Parameters.Add("tel", tel);
        mycmd.Parameters.Add("fax", fax);
        mycmd.Parameters.Add("pcphone", pcphone);
        mycmd.Parameters.Add("email", email);
        mycmd.Parameters.Add("yb", yb);
        mycmd.Parameters.Add("qq", qq);
        mycmd.Parameters.Add("addr", addr);
        mycmd.Parameters.Add("addtime", addtime);
        mycmd.Parameters.Add("question", question);
        mycmd.Parameters.Add("answer", answer);
        mycmd.Parameters.Add("id", id);
        mycon.Open();
        mycmd.ExecuteNonQuery();
        mycon.Close();
    }




    //*****************************************************************
    //作用：反回与当前同类的所有记录中的最大index
    //参数：相关内容
    //返回值：无
    //*****************************************************************
    /// <summary>
    /// 
    /// <param name="self_id">当前编号</param>
    /// <returns></returns> 
    /// </summary>

    public int returnmaxindex(int self_id)
    {
        int flag = -1;
        OleDbCommand mycmd = new OleDbCommand("select parent_id from productclass where self_id=" + self_id, mycon);
        mycon.Open();
        OleDbDataReader reader = mycmd.ExecuteReader();
        if (reader.HasRows)
        {
            reader.Read();
            if (reader["parent_id"].ToString().Equals(""))
            {
                OleDbConnection con = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + System.Web.HttpContext.Current.Server.MapPath(System.Configuration.ConfigurationManager.AppSettings["constring"].ToString()));
                OleDbCommand cmd1 = new OleDbCommand("select max(theindex) as maxindex from productclass where parent_id is null", con);
                con.Open();
                OleDbDataReader reader1 = cmd1.ExecuteReader();
                if (reader1.HasRows)
                {
                    reader1.Read();
                    if (reader1["maxindex"].ToString().Equals(""))
                        flag = 0;
                    else
                        flag = Convert.ToInt32(reader1["maxindex"].ToString());
                }
                reader1.Close();
                con.Close();
            }
            else
            {
                OleDbConnection con = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + System.Web.HttpContext.Current.Server.MapPath(System.Configuration.ConfigurationManager.AppSettings["constring"].ToString()));
                OleDbCommand cmd1 = new OleDbCommand("select max(theindex) as maxindex from productclass where parent_id=" + reader["parent_id"].ToString(), con);
                con.Open();
                OleDbDataReader reader1 = cmd1.ExecuteReader();
                if (reader1.HasRows)
                {
                    reader1.Read();
                    if (reader1["maxindex"].ToString().Equals(""))
                        flag = 0;
                    else
                        flag = Convert.ToInt32(reader1["maxindex"].ToString());
                }
                reader1.Close();
                con.Close();
            }
        }
        reader.Close();
        mycon.Close();
        return flag;
    }



    //*****************************************************************
    //作用：反回联系信息
    //参数：相关内容
    //返回值：无
    //*****************************************************************


    public OleDbDataReader returnconinfo()
    {
        OleDbCommand mycmd = new OleDbCommand("select *  from coninfo", mycon);
        mycon.Open();
        OleDbDataReader reader = mycmd.ExecuteReader();
        return reader;
    }



    //*****************************************************************
    //作用：根所要求反回新闻列表
    //参数：相关内容
    //返回值：无
    //*****************************************************************

    public OleDbDataReader newslisthelper(string top, string type, string need)
    {
        OleDbCommand mycmd = new OleDbCommand("select " + top + " " + need + " from news where news_group=(select id from newsgroup where news_groupname=\"" + type + "\") order by AddedDate desc,news_id desc", mycon);
        if (mycon.State == ConnectionState.Closed)
            mycon.Open();
        OleDbDataReader reader = mycmd.ExecuteReader();
        return reader;
    }


    //重构返回dataset
    public DataSet newslisthelper(string top, string type, string need, string flag)
    {
        OleDbCommand mycmd = new OleDbCommand("select " + top + " " + need + " from news where news_group=(select id from newsgroup where news_groupname=\"" + type + "\") order by AddedDate desc,news_id desc", mycon);
        if (mycon.State == ConnectionState.Closed)
            mycon.Open();
              OleDbDataAdapter da = new OleDbDataAdapter();
        DataSet ds = new DataSet();
        da.SelectCommand = mycmd;
        da.Fill(ds, flag);
        mycon.Close();
        return ds;
    }

    //*****************************************************************
    //作用：根所要求反回模块产品列表
    //参数：相关内容
    //返回值：无
    //*****************************************************************
    public OleDbDataReader productmkhelper(string top, string type, string need)
    {
        OleDbCommand mycmd = new OleDbCommand("select " + top + " " + need + " from productmkdetail where mkid=(select id from productmk where mkname=\"" + type + "\") order by theindex,id", mycon);
        if (mycon.State == ConnectionState.Closed)
            mycon.Open();
        OleDbDataReader reader = mycmd.ExecuteReader();
        return reader;
    }
    //重构返回dataset
    public DataSet productmkhelper(string top, string type, string need, string flag)
    {
        OleDbCommand mycmd = new OleDbCommand("select " + top + " " + need + " from productmkdetail where mkid=(select id from productmk where mkname=\"" + type + "\") order by theindex,id", mycon);
        if (mycon.State == ConnectionState.Closed)
            mycon.Open();
        OleDbDataAdapter da = new OleDbDataAdapter();
        DataSet ds = new DataSet();
        da.SelectCommand = mycmd;
        da.Fill(ds, flag);
        mycon.Close();
        return ds;
    }
}