﻿using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;

public class mtype
{
    protected string selfcode, parentcode;
    public string Selfcode
    {
        get { return selfcode; }
        set { selfcode = value; }
    }
    public string Parentcode
    {
        get { return parentcode; }
        set { parentcode = value; }
    }
    public mtype(string _selfcode, string _parentcode)
    {
        selfcode = _selfcode;
        parentcode = _parentcode;
    }
}

public class typeinfo
{
    protected string thename;
    protected string selfcode;
    public string Thename
    {
        get { return thename; }
        set { thename = value; }
    }
    public string Selfcode
    {
        get { return selfcode; }
        set { selfcode = value; }
    }
    public typeinfo(string _thename, string _selfcode)
    {
        thename = _thename;
        selfcode = _selfcode;
    }
}
/// <summary>
///producttype 的摘要说明
/// <param name="typecode">类型自身编号</param>
/// <para name="leafcode">存放返回值以【a,b,】形式</para>
/// </summary>
public class producttype
{
    public static List<mtype> types = new List<mtype>();
    static producttype()
    {
        if (types.Count < 1)
            types = inittypes();
    }
    #region   获取把有类型编号
    public static List<mtype> inittypes()
    {
        List<mtype> temptype = new List<mtype>();
        OleDbConnection con = new OleDbConnection(theconnectstring.constring);
        OleDbCommand cmd = new OleDbCommand("select selfcode,parentcode from glasstype", con);
        con.Open();
        OleDbDataReader reader = cmd.ExecuteReader();
        if (reader.HasRows)
        {
            while (reader.Read())
            {
                temptype.Add(new mtype(reader["selfcode"].ToString().Trim(), reader["parentcode"].ToString().Trim()));
            }
        }
        reader.Close();
        con.Close();
        return temptype;
    }
    #endregion
    #region   获取树形列表
    public static string getTreeh(DataTable dtSource, string parentID, string urls)
    {
        string html = "";

        DataRow[] rows = dtSource.Select(string.Format("parentcode='{0}'", parentID));
        foreach (DataRow row in rows)
        {
            //html += "<li><a href=\"" + urls + "?cateID=" + row["id"].ToString() + "\" >" + row["Names"].ToString() + getNum(row["id"].ToString()) + "</a>";
            html += "<li><a href=\"" + urls + "?cid=" + row["selfcode"].ToString() + "\" >" + row["thename"].ToString() + "</a>";
            html += getTreeh(dtSource, row["selfcode"].ToString(), urls);
            dtSource.Rows.Remove(row);
            html = html + "</li>\n";

        }
        if (html != "")
        {
            html = "<ul>\n" + html + "</ul>\n";
        }
        return html;

    }
    #endregion

    #region  是最终节点为真，不是为假
    protected static bool isleafnode(string typecode)
    {
        bool flag = false;
        foreach (mtype t in types)
        {
            if (t.Parentcode.Equals(typecode))
            {
                flag = true;
                break;
            }
        }

        if (flag)  //是父节点
        {
            return false;
        }
        else
            return true;
    }
    #endregion
    #region  得到一类型的所有叶子类型
    public static void getallleafnode(string typecode, List<string> valuetype)
    {
        if (isleafnode(typecode))
        {
            valuetype.Add(typecode);
        }
        else
        {
            List<string> temptype = new List<string>();
            foreach (mtype t in types)  //查找typecode子类
            {
                if (t.Parentcode.Equals(typecode))
                {
                    temptype.Add(t.Selfcode);
                }
            }

            foreach (string t in temptype)
            {
                getallleafnode(t, valuetype);
            }
        }
    }
    #endregion

    #region  获取当前类的所有父类
    /// <summary>
    /// 获取当前类的所有父类
    /// </summary>
    /// <param name="typecode">类别编号</param>
    /// <param name="parents">返回值接收参数为倒序，包含自身请调用时加入自身编号</param>
    public static void allparent(string typecode, List<typeinfo> parents)
    {
        foreach (mtype t in types)
        {
            if (t.Selfcode.Equals(typecode.Trim()))
            {
                if (t.Parentcode.Equals("-1"))  //已找完所有父类
                {
                    OleDbConnection con = new OleDbConnection(theconnectstring.constring);
                    OleDbCommand cmd = new OleDbCommand("select thename from glasstype where selfcode=?", con);
                    con.Open();
                    foreach (typeinfo it in parents)
                    {
                        cmd.Parameters.Add("selfcode", it.Selfcode);
                        OleDbDataReader reader = cmd.ExecuteReader();
                        if (reader.HasRows)
                        {
                            reader.Read();
                            it.Thename = reader["thename"].ToString();
                        }
                        reader.Close();
                        cmd.Parameters.Clear();
                    }
                    con.Close();
                }
                else
                {
                    parents.Add(new typeinfo("", t.Parentcode));
                    allparent(t.Parentcode, parents);
                }
            }
        }
    }
    #endregion

    public static string[] getparent(string selfcode)
    {
        string[] parent = { "-1", "-1", "-1", "notroot" };
        OleDbConnection con = new OleDbConnection(theconnectstring.constring);
        OleDbCommand cmd = new OleDbCommand("select selfcode,thename,smallpic from glasstype where selfcode=(select parentcode from glasstype where selfcode=?)", con);
        cmd.Parameters.Add("selfcode", selfcode);
        con.Open();
        OleDbDataReader reader = cmd.ExecuteReader();
        if (reader.HasRows)
        {
            reader.Read();
            parent[0] = reader["selfcode"].ToString();
            parent[1] = reader["thename"].ToString();
            parent[2] = reader["smallpic"].ToString();
            reader.Close();
        }
        else
        {
            reader.Close();
            cmd.Parameters.Clear();
            cmd.CommandText = "select selfcode,thename,smallpic from glasstype where selfcode=?";
            cmd.Parameters.Add("selfcode", selfcode);
            reader = cmd.ExecuteReader();
            reader.Read();
            parent[0] = reader["selfcode"].ToString();
            parent[1] = reader["thename"].ToString();
            parent[2] = reader["smallpic"].ToString();
            parent[3] = "root";
        }
        con.Close();
        return parent;
    }
}

public class enproducttype
{
    public static List<mtype> types = new List<mtype>();
    static enproducttype()
    {
        if (types.Count < 1)
            types = inittypes();
    }
    #region   获取把有类型编号
    public static List<mtype> inittypes()
    {
        List<mtype> temptype = new List<mtype>();
        OleDbConnection con = new OleDbConnection(theconnectstring.enconstring);
        OleDbCommand cmd = new OleDbCommand("select selfcode,parentcode from glasstype", con);
        con.Open();
        OleDbDataReader reader = cmd.ExecuteReader();
        if (reader.HasRows)
        {
            while (reader.Read())
            {
                temptype.Add(new mtype(reader["selfcode"].ToString().Trim(), reader["parentcode"].ToString().Trim()));
            }
        }
        reader.Close();
        con.Close();
        return temptype;
    }
    #endregion

    #region  是最终节点为真，不是为假
    public static bool isleafnode(string typecode)
    {
        bool flag = false;
        foreach (mtype t in types)
        {
            if (t.Parentcode.Equals(typecode))
            {
                flag = true;
                break;
            }
        }

        if (flag)  //是父节点
        {
            return false;
        }
        else
            return true;
    }
    #endregion
    
    #region  得到一类型的所有叶子类型
    public static void getallleafnode(string typecode, List<string> valuetype)
    {
        if (isleafnode(typecode))
        {
            valuetype.Add(typecode);
        }
        else
        {
            List<string> temptype = new List<string>();
            foreach (mtype t in types)  //查找typecode子类
            {
                if (t.Parentcode.Equals(typecode))
                {
                    temptype.Add(t.Selfcode);
                }
            }

            foreach (string t in temptype)
            {
                getallleafnode(t, valuetype);
            }
        }
    }
    #endregion

    #region  获取当前类的所有父类
    /// <summary>
    /// 获取当前类的所有父类
    /// </summary>
    /// <param name="typecode">类别编号</param>
    /// <param name="parents">返回值接收参数为倒序，包含自身请调用时加入自身编号</param>
    public static void allparent(string typecode, List<typeinfo> parents)
    {
        foreach (mtype t in types)
        {
            if (t.Selfcode.Equals(typecode.Trim()))
            {
                if (t.Parentcode.Equals("-1"))  //已找完所有父类
                {
                    OleDbConnection con = new OleDbConnection(theconnectstring.enconstring);
                    OleDbCommand cmd = new OleDbCommand("select thename from glasstype where selfcode=?", con);
                    con.Open();
                    foreach (typeinfo it in parents)
                    {
                        cmd.Parameters.Add("selfcode", it.Selfcode);
                        OleDbDataReader reader = cmd.ExecuteReader();
                        if (reader.HasRows)
                        {
                            reader.Read();
                            it.Thename = reader["thename"].ToString();
                        }
                        reader.Close();
                        cmd.Parameters.Clear();
                    }
                    con.Close();
                }
                else
                {
                    parents.Add(new typeinfo("", t.Parentcode));
                    allparent(t.Parentcode, parents);
                }
            }
        }
    }
    #endregion

    public static string[] getparent(string selfcode)
    {
        string[] parent = { "-1", "-1", "-1", "notroot" };
        OleDbConnection con = new OleDbConnection(theconnectstring.enconstring);
        OleDbCommand cmd = new OleDbCommand("select selfcode,thename,smallpic from glasstype where selfcode=(select parentcode from glasstype where selfcode=?)", con);
        cmd.Parameters.Add("selfcode", selfcode);
        con.Open();
        OleDbDataReader reader = cmd.ExecuteReader();
        if (reader.HasRows)
        {
            reader.Read();
            parent[0] = reader["selfcode"].ToString();
            parent[1] = reader["thename"].ToString();
            parent[2] = reader["smallpic"].ToString();
            reader.Close();
        }
        else
        {
            reader.Close();
            cmd.Parameters.Clear();
            cmd.CommandText = "select selfcode,thename,smallpic from glasstype where selfcode=?";
            cmd.Parameters.Add("selfcode", selfcode);
            reader = cmd.ExecuteReader();
            reader.Read();
            parent[0] = reader["selfcode"].ToString();
            parent[1] = reader["thename"].ToString();
            parent[2] = reader["smallpic"].ToString();
            parent[3] = "root";
        }
        con.Close();
        return parent;
    }
}