﻿//using System.Web.UI.WebControls;
using System.IO;
using System.Drawing.Imaging;
/// <summary>
/// smallpic 的摘要说明
/// </summary>
public class smallpic
{
    public smallpic()
    {
        //
        // TODO: 在此处添加构造函数逻辑
        //
    }

    /// <summary>
    /// 生成缩略图
    /// </summary>
    /// <param name="originalImagePath">源图路径（物理路径）</param>
    /// <param name="thumbnailPath">缩略图路径（物理路径）</param>
    /// <param name="width">缩略图宽度</param>
    /// <param name="height">缩略图高度</param>
    /// <param name="mode">生成缩略图的方式</param>
    public static bool MakeThumbnail(string originalImagePath, string thumbnailPath, int width, int height, string mode)
    {
        System.Drawing.Image originalImage = System.Drawing.Image.FromFile(originalImagePath);
        int towidth = width;
        int toheight = height;
        int x = 0;
        int y = 0;
        int ow = originalImage.Width;
        int oh = originalImage.Height;
            switch (mode)
            {
                case "HW"://指定高宽缩放（可能变形）                
                    break;
                case "W"://指定宽，高按比例                    
                    toheight = originalImage.Height * width / originalImage.Width;
                    break;
                case "H"://指定高，宽按比例
                    towidth = originalImage.Width * height / originalImage.Height;
                    break;
                case "Cut"://指定高宽裁减（不变形）                
                    if ((double)originalImage.Width / (double)originalImage.Height > (double)towidth / (double)toheight)
                    {
                        oh = originalImage.Height;
                        ow = originalImage.Height * towidth / toheight;
                        y = 0;
                        x = (originalImage.Width - ow) / 2;
                    }
                    else
                    {
                        ow = originalImage.Width;
                        oh = originalImage.Width * height / towidth;
                        x = 0;
                        y = (originalImage.Height - oh) / 2;
                    }
                    break;
                default:
                    break;
            }

            //新建一个bmp图片
            System.Drawing.Image bitmap = new System.Drawing.Bitmap(towidth, toheight);

            //新建一个画板
            System.Drawing.Graphics g = System.Drawing.Graphics.FromImage(bitmap);

            //设置高质量插值法
            g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.High;

            //设置高质量,低速度呈现平滑程度
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

            //清空画布并以透明背景色填充
            g.Clear(System.Drawing.Color.Transparent);

            //在指定位置并且按指定大小绘制原图片的指定部分
            g.DrawImage(originalImage, new System.Drawing.Rectangle(0, 0, towidth, toheight),
                new System.Drawing.Rectangle(x, y, ow, oh),
                System.Drawing.GraphicsUnit.Pixel);

            try
            {
                //以jpg格式保存缩略图
                bitmap.Save(thumbnailPath, System.Drawing.Imaging.ImageFormat.Jpeg);
                return true;
            }
            catch (System.Exception e)
            {
                return false;
                throw e;

            }
            finally
            {
                originalImage.Dispose();
                bitmap.Dispose();
                g.Dispose();
            }
    }
    public static void MakeThumbnail(Stream oldpic, string thumbnailPath, int width, int height, string mode, string type,bool flag)
    {
        System.Drawing.Image originalImage = System.Drawing.Image.FromStream(oldpic);
        float towidth = 0;
        float toheight = 0;
        float x = 0;
        float y = 0;
        float ow = originalImage.Width;
        float oh = originalImage.Height;
        if (oh <= height && ow <= width)//如果已是<=要保存的则不用管它
        {
            towidth = ow;
            toheight = oh;
        }
        else
        {
            if (ow / oh > width / height)//说是有宽形的
            {
                toheight = oh * (width / ow);
                towidth = width;
            }
            else  //说明是长形的
            {
                towidth = ow * (height / oh);
                toheight = height;
            }
        }

        x = (width - towidth) / 2;
        y = (height - toheight) / 2;

        if (!flag)
        {
            x = 0;
            y = 0;
            width = (int)towidth;
            height = (int)toheight;
        }


        //新建一个bmp图片
        System.Drawing.Image bitmap = new System.Drawing.Bitmap(width, height);

        //新建一个画板
        System.Drawing.Graphics g = System.Drawing.Graphics.FromImage(bitmap);

        //设置高质量插值法
        g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;

        //设置高质量,低速度呈现平滑程度
        g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

        //清空画布并以透明背景色填充
        g.Clear(System.Drawing.Color.White);

        //在指定位置并且按指定大小绘制原图片的指定部分
        g.DrawImage(originalImage, (float)x, (float)y, (float)towidth, (float)toheight);

        long[] quality = new long[1];
        quality[0] = 100;
        System.Drawing.Imaging.EncoderParameters encoderParams = new System.Drawing.Imaging.EncoderParameters();
        System.Drawing.Imaging.EncoderParameter encoderParam = new System.Drawing.Imaging.EncoderParameter(System.Drawing.Imaging.Encoder.Quality, quality);
        encoderParams.Param[0] = encoderParam;
        ImageCodecInfo[] arrayICI = ImageCodecInfo.GetImageEncoders();//获得包含有关内置图像编码解码器的信息的ImageCodecInfo 对象。
        ImageCodecInfo jpegICI = null;
        for (int i = 0; i < arrayICI.Length; i++)
        {
            if (arrayICI[i].FormatDescription.Equals("JPEG"))
            {
                jpegICI = arrayICI[i];//设置JPEG编码
                break;
            }
        }
        try
        {
            //保存缩略图
            if (type == "JPG")
            {
                bitmap.Save(thumbnailPath, jpegICI, encoderParams);
            }
            if (type == "BMP")
            {
                bitmap.Save(thumbnailPath, jpegICI, encoderParams);
            }
            if (type == "GIF")
            {
                bitmap.Save(thumbnailPath, jpegICI, encoderParams);
            }
            if (type == "PNG")
            {
                bitmap.Save(thumbnailPath, jpegICI, encoderParams);
            }
            if (type == "TIFF")
            {
                bitmap.Save(thumbnailPath, jpegICI, encoderParams);
            }
        }
        catch (System.Exception e)
        {
            throw e;
        }
        finally
        {
            originalImage.Dispose();
            bitmap.Dispose();
            g.Dispose();
        }
    }

}