﻿<%@ WebHandler Language="C#" Class="Upload" %>

using System;
using System.Collections;
using System.Web;
using System.IO;
using System.Globalization;
using LitJson;
using System.Web.SessionState;

public class Upload : IHttpHandler, IRequiresSessionState
{
    private HttpContext context;

    public void ProcessRequest(HttpContext context)
    {

        String aspxUrl = context.Request.Path.Substring(0, context.Request.Path.LastIndexOf("/") + 1);
        //文件保存目录路径
        String savePath = "../../newsimage/";

        //文件保存目录URL
        String saveUrl = "/newsimage/";

        //定义允许上传的文件扩展名
        Hashtable extTable = new Hashtable();
        extTable.Add("image", "gif,jpg,jpeg,png,bmp");
        extTable.Add("flash", "swf,flv");
        extTable.Add("media", "swf,flv,mp3,wav,wma,wmv,mid,avi,mpg,asf,rm,rmvb");
        extTable.Add("file", "doc,docx,xls,xlsx,ppt,htm,html,txt,zip,rar,gz,bz2");

        //最大文件大小
        int maxSize = 5 * 1024 * 1024;
        this.context = context;

        HttpPostedFile imgFile = context.Request.Files["imgFile"];
        if (context.Session["check"] == null)
        {
            showError("后台登陆过期，请重新登录.", context);
        }
        if (imgFile == null)
        {
            showError("请选择文件。", context);
        }

        String dirPath = context.Server.MapPath(savePath);
        if (!Directory.Exists(dirPath))
        {
            showError("上传目录不存在。", context);
        }

        String dirName = context.Request.QueryString["dir"];
        if (String.IsNullOrEmpty(dirName))
        {
            dirName = "image";
        }
        if (!extTable.ContainsKey(dirName))
        {
            showError("目录名不正确。", context);
        }

        String fileName = imgFile.FileName;
        String fileExt = Path.GetExtension(fileName).ToLower();

        if (imgFile.InputStream == null || imgFile.InputStream.Length > maxSize)
        {
            showError("上传文件大小超过限制。", context);
        }

        if (String.IsNullOrEmpty(fileExt) || Array.IndexOf(((String)extTable[dirName]).Split(','), fileExt.Substring(1).ToLower()) == -1)
        {
            showError("上传文件扩展名是不允许的扩展名。\n只允许" + ((String)extTable[dirName]) + "格式。", context);
        }
        //创建文件夹
        dirPath += dirName + "/";
        saveUrl += dirName + "/";
        if (!Directory.Exists(dirPath))
        {
            Directory.CreateDirectory(dirPath);
        }
        String ymd = DateTime.Now.ToString("yyyyMMdd", DateTimeFormatInfo.InvariantInfo);
        dirPath += ymd + "/";
        saveUrl += ymd + "/";
        if (!Directory.Exists(dirPath))
        {
            Directory.CreateDirectory(dirPath);
        }

        String newFileName = DateTime.Now.ToString("yyyyMMddHHmmss_ffff", DateTimeFormatInfo.InvariantInfo) + fileExt;
        String filePath = dirPath + newFileName;

        imgFile.SaveAs(filePath);

        String fileUrl = saveUrl + newFileName;

        Hashtable hash = new Hashtable();
        hash["error"] = 0;
        hash["url"] = fileUrl;
        ////判断上传的文件类型
        //if (context.Request.QueryString["dir"] == "image")
        //{
        //    //请求中有width这个参数表示图片需要进行处理
        //    if (context.Request.QueryString["width"] != null)
        //    {   //缩略图相对地址
        //        string thumbfilePath = dirPath + "Thumb_" + newFileName;
        //        int width = Convert.ToInt32(context.Request.QueryString["width"]);
        //        int height = Convert.ToInt32(context.Request.QueryString["height"]);
        //        //获得原始图片的宽和高
        //        System.Drawing.Image originalImage = System.Drawing.Image.FromFile(filePath);
        //        int ow = originalImage.Width;
        //        int oh = originalImage.Height;
        //        //如果原图的尺寸比缩略图要求的尺寸小,则不进行任何处理
        //        if (width < ow)
        //        {
        //            //生成缩略图
        //            if (smallpic.MakeThumbnail(filePath, thumbfilePath, width, height, "W"))
        //            {
        //                string smillUrl = saveUrl + "Thumb_" + newFileName;
        //                //File.Delete(filePath);
        //                hash["url"] = smillUrl;
        //            }
        //            else
        //            {
        //                showError("生成缩略图失败", context);
        //            }
        //        }
        //    }
        //}
        context.Response.AddHeader("Content-Type", "text/html; charset=UTF-8");
        context.Response.Write(JsonMapper.ToJson(hash));
        context.Response.End();
    }

    private void showError(string message, HttpContext context)
    {
        Hashtable hash = new Hashtable();
        hash["error"] = 1;
        hash["message"] = message;
        context.Response.AddHeader("Content-Type", "text/html; charset=UTF-8");
        context.Response.Write(JsonMapper.ToJson(hash));
        context.Response.End();
    }

    public bool IsReusable
    {
        get
        {
            return true;
        }
    }
}
