﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Data.OleDb;

/// <summary>
/// Author:walkingp
/// Web Site:http://www.51obj.cn/
/// E-mail:walkingp@126.com
/// </summary>
public partial class manage_ManageSQL : RePage
{
    protected void Page_Load(object sender, EventArgs e)
    {

        if (Session["check"].ToString().Equals("admin"))
        {
            btnExeSql.Enabled = true;
            txtSQL.Enabled = true;
        }
        else
        {
            btnExeSql.Enabled = false;
            txtSQL.Enabled = false;
        }
        if (!IsPostBack)
        {
            GetTableName();
        }
    }

    #region OleDbConnection
    /// <summary>
    /// 初始化OleDbConnection
    /// </summary>
    private static OleDbConnection connection;

    public static OleDbConnection Connection
    {
        get
        {
            string connectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + System.Web.HttpContext.Current.Server.MapPath(System.Configuration.ConfigurationManager.AppSettings["constring"].ToString());   //数据库连接串
            if (connection == null)
            {
                connection = new OleDbConnection(connectionString);
                connection.Open();
            }
            else if (connection.State == System.Data.ConnectionState.Closed)
            {
                connection.Open();
            }
            else if (connection.State == System.Data.ConnectionState.Broken)
            {
                connection.Close();
                connection.Open();
            }
            return connection;
        }
    }

    /// <summary>
    /// 执行Sql
    /// </summary>
    /// <param name="sql">Sql</param>
    /// <returns>影响记录条数</returns>
    public static int ExecuteCommand(string safeSql)
    {
        OleDbCommand cmd = new OleDbCommand(safeSql, Connection);

        int result = cmd.ExecuteNonQuery();
        return result;
    }
    /// <summary>
    /// 执行Sql(overload)
    /// </summary>
    /// <param name="sql">Sql</param>
    /// <param name="values">SqlParameter</param>
    /// <returns>影响记录条数</returns>
    public static int ExecuteCommand(string sql, params SqlParameter[] values)
    {
        OleDbCommand cmd = new OleDbCommand(sql, Connection);
        cmd.Parameters.AddRange(values);
        return cmd.ExecuteNonQuery();
    }

    /// <summary>
    /// 获取DataTable
    /// </summary>
    /// <param name="safeSql">Sql</param>
    /// <returns>DataTable</returns>
    public static DataTable GetDataSet(string safeSql)
    {
        DataSet ds = new DataSet();
        OleDbCommand cmd = new OleDbCommand(safeSql, Connection);
        OleDbDataAdapter da = new OleDbDataAdapter(cmd);
        da.Fill(ds);
        return ds.Tables[0];
    }
    #endregion

    /// <summary>
    /// 获取数据表结构
    /// </summary>
    protected void GetTableName()
    {
        DataTable dt = Connection.GetSchema("Tables", null);
        Connection.Close();
        grdTable.DataSource = dt;
        grdTable.DataBind();
    }

    /// <summary>
    /// 执行操作
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnExeSql_Click(object sender, EventArgs e)
    {
        string sql = txtSQL.Text.Trim().ToLower();
        int intExeNum;

        try
        {
            if (sql.Substring(0, 6).IndexOf("select") != -1)
            {
                DataTable dt = GetDataSet(sql);
                grdSQL.DataSource = dt;
                grdSQL.DataBind();
                lblExeNum.Text = "返回记录条数：<strong>" + dt.Rows.Count + "</strong>";
                grdSQL.Visible = true;
            }
            else if (sql.Substring(0, 6).IndexOf("delete") != -1 || sql.Substring(0, 6).IndexOf("update") != -1 || sql.Substring(0, 6).IndexOf("insert") != -1)
            {
                intExeNum = ExecuteCommand(sql);
                lblExeNum.Text = "影响行数：<strong>" + intExeNum + "</strong>";
                grdSQL.Visible = false;
            }
        }
        catch (Exception ex)
        {
            ClientScript.RegisterStartupScript(typeof(string), "", "document.write(\"<h4 style=\'font-size:14px;color:#c00;padding-left:20px;\'>抱歉，系统发生了错误……错误信息：" + ex.Message.Replace("\"", "'") + "</h4>\")", true);
        }
    }

    /// <summary>
    /// 执行按钮可用
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void txtSQL_TextChanged(object sender, EventArgs e)
    {
        btnExeSql.Enabled = true;
    }
}
