﻿using System;
using MsShop.Common;
using System.Text;
using System.Data.OleDb;
using System.Data;

public partial class Product_Attributes_edit : RePage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            try
            {
                StringBuilder strSql = new StringBuilder();
                strSql.Append("select id,Name,Sort from Product_Attributes ");
                strSql.Append(" where id=@id");
                OleDbParameter[] parameters = {
					new OleDbParameter("@id", OleDbType.Integer)
			};
                parameters[0].Value = (int)Session["id"];
                DataSet ds = DBUtility.DbHelperOleDb.Query(strSql.ToString(), parameters);
                if (ds.Tables[0].Rows.Count > 0)
                {


                    txtKeywords.Text = ds.Tables[0].Rows[0]["Name"].ToString();
                    txtFrequency.Text = ds.Tables[0].Rows[0]["Sort"].ToString();
                }
            }
            catch
            {
                Messageshow1.Msg = "商品标签信息加载失败,请重新选择标签修改";
                Messageshow1.Infotype = "0";
                Messageshow1.Visible = true;
            }
        }
    }

    protected void Button7_Click(object sender, EventArgs e)
    {
        Response.Redirect("Product_Attributes_manage.aspx");
    }

    protected void Button6_Click(object sender, EventArgs e)
    {
        string strErr = "";
        if (this.txtKeywords.Text.Trim().Length == 0)
        {
            strErr += "商品标签名称不能为空！";
        }
        if (!PageValidate.IsNumber(txtFrequency.Text))
        {
            strErr += "排序码格式错误！";
        }

        if (strErr != "")
        {
            Messageshow1.Msg = strErr;
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true;
            return;
        }

        string Keywords = this.txtKeywords.Text;
        int Frequency = int.Parse(this.txtFrequency.Text);
        StringBuilder strSql = new StringBuilder();
        strSql.Append("update Product_Attributes set ");
        strSql.Append("Name=@Name,");
        strSql.Append("Sort=@Sort");
        strSql.Append(" where id=@id");
        OleDbParameter[] parameters = {
					new OleDbParameter("@Name", OleDbType.Char,255),
					new OleDbParameter("@Sort", OleDbType.Integer),
					new OleDbParameter("@id", OleDbType.Integer)};
        parameters[0].Value = Keywords;
        parameters[1].Value = Frequency;
        parameters[2].Value = (int)Session["id"];

        int rows = DBUtility.DbHelperOleDb.ExecuteSql(strSql.ToString(), parameters);
        if (rows>0)
        {
            Messageshow1.Msg = "修改成功！";
            Messageshow1.Infotype = "1";
            Messageshow1.Visible = true;
        }
        else
        {
            Messageshow1.Msg = "修改失败！";
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true;
        }
    }
}
