﻿using MsShop.Common;
using System;
using System.Text;
using System.Data;
using System.Data.OleDb;

public partial class advert_position_add : RePage
{
    void init()
    {
        if (txtShowType.SelectedValue != "3")
        {
            adsize.Visible = true;
            adrepeat.Visible = true;
            adarea.Visible = false;
        }
        else
        {
            adsize.Visible = false;
            adrepeat.Visible = false;
            adarea.Visible = true;
        }
        if (txtShowType.SelectedValue == "2")
        {
            adrepeat.Visible = true;
        }
        else
        {
            adrepeat.Visible = false;
        }
    }


    protected void Page_Load(object sender, EventArgs e)
    {

        if (!IsPostBack)
        {
            init();
        }
    }

    protected void showtype_SelectedIndexChanged(object sender, EventArgs e)
    {
        init();
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        string strErr = "";
        if (this.txtAdvPositionName.Text.Trim().Length == 0)
        {
            strErr += "广告位名称不能为空！";
        }
        if (!PageValidate.IsNumber(txtRepeatColumns.Text))
        {
            strErr += "行显个数格式错误！";
        }
        if (!PageValidate.IsNumber(txtWidth.Text))
        {
            strErr += "宽度格式错误！";
        }
        if (!PageValidate.IsNumber(txtHeight.Text))
        {
            strErr += "高度格式错误！";
        }

        if (strErr != "")
        {
            Messageshow1.Msg = strErr;
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true; return;
        }
        string AdvPositionName = this.txtAdvPositionName.Text;
        int ShowType = int.Parse(this.txtShowType.Text);
        int RepeatColumns = int.Parse(this.txtRepeatColumns.Text);
        int Width = int.Parse(this.txtWidth.Text);
        int Height = int.Parse(this.txtHeight.Text);
        string AdvHtml = this.txtAdvHtml.Text;


        StringBuilder strSql = new StringBuilder();
        strSql.Append("insert into AdvPositions(");
        strSql.Append("AdvPositionName,ShowType,RepeatColumns,Width,Height,AdvHtml)");
        strSql.Append(" values (");
        strSql.Append("@AdvPositionName,@ShowType,@RepeatColumns,@Width,@Height,@AdvHtml)");
        OleDbParameter[] parameters = {
					new OleDbParameter("@AdvPositionName", OleDbType.Char,100),
					new OleDbParameter("@ShowType", DbType.Int32),
					new OleDbParameter("@RepeatColumns", DbType.Int32),
					new OleDbParameter("@Width", DbType.Int32),
					new OleDbParameter("@Height", DbType.Int32),
					new OleDbParameter("@AdvHtml", OleDbType.Char,0)};
        parameters[0].Value = AdvPositionName;
        parameters[1].Value = ShowType;
        parameters[2].Value = RepeatColumns;
        parameters[3].Value = Width;
        parameters[4].Value = Height;
        parameters[5].Value = AdvHtml;

        int rows = DBUtility.DbHelperOleDb.ExecuteSql(strSql.ToString(), parameters);
        if (rows > 0)
        {
            MsShop.Common.MessageBox.ShowAndRedirect(this, "保存成功！", "advert_position_add.aspx");
        }
        else
        {
            Messageshow1.Msg = "广告位添加失败";
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true;
        }
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        Response.Redirect("advert_position_manage.aspx");
    }
}
