﻿using System;
using MsShop.Common;
using System.Text;
using System.Data;
using System.Data.OleDb;
public partial class advert_position_edit : RePage
{
    void init()
    {
        try
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select AdvPositionId,AdvPositionName,ShowType,RepeatColumns,Width,Height,AdvHtml from AdvPositions ");
            strSql.Append(" where AdvPositionId=@AdvPositionId");
            OleDbParameter[] parameters = {
					new OleDbParameter("@AdvPositionId", DbType.Int32)
			};
            parameters[0].Value = (int)Session["id"];
            DataSet ds = DBUtility.DbHelperOleDb.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                txtShowType.SelectedIndex = (int)ds.Tables[0].Rows[0]["ShowType"] - 1;
                txtAdvPositionName.Text = ds.Tables[0].Rows[0]["AdvPositionName"].ToString().Trim();
                txtWidth.Text = ds.Tables[0].Rows[0]["Width"].ToString();
                txtHeight.Text = ds.Tables[0].Rows[0]["Height"].ToString();
                txtRepeatColumns.Text = ds.Tables[0].Rows[0]["RepeatColumns"].ToString();
                txtAdvHtml.Text = ds.Tables[0].Rows[0]["AdvHtml"].ToString();
            }
            if (txtShowType.SelectedValue != "3")
            {
                adsize.Visible = true;
                adrepeat.Visible = true;
                adarea.Visible = false;
            }
            else
            {
                adsize.Visible = false;
                adrepeat.Visible = false;
                adarea.Visible = true;
            }
            if (txtShowType.SelectedValue == "2")
            {
                adrepeat.Visible = true;
            }
            else
            {
                adrepeat.Visible = false;
            }
        }
        catch
        {
            Messageshow1.Msg = "数据加载失败，请不要执行修改操作";
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true;
        }

    }
    void init1()
    {
        if (txtShowType.SelectedValue != "3")
        {
            adsize.Visible = true;
            adrepeat.Visible = true;
            adarea.Visible = false;
        }
        else
        {
            adsize.Visible = false;
            adrepeat.Visible = false;
            adarea.Visible = true;
        }
        if (txtShowType.SelectedValue == "2")
        {
            adrepeat.Visible = true;
        }
        else
        {
            adrepeat.Visible = false;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            try
            {
                init();
            }
            catch
            {
                Messageshow1.Msg = "数据加载失败";
                Messageshow1.Infotype = "2";
                Messageshow1.Visible = true;
            }
        }
    }

    protected void showtype_SelectedIndexChanged(object sender, EventArgs e)
    {
        init1();
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        string strErr = "";
        if (this.txtAdvPositionName.Text.Trim().Length == 0)
        {
            strErr += "广告位名称不能为空！";
        }
        if (!PageValidate.IsNumber(txtRepeatColumns.Text))
        {
            strErr += "行显个数格式错误！";
        }
        if (!PageValidate.IsNumber(txtWidth.Text))
        {
            strErr += "宽度格式错误！";
        }
        if (!PageValidate.IsNumber(txtHeight.Text))
        {
            strErr += "高度格式错误！";
        }

        if (strErr != "")
        {
            Messageshow1.Msg = strErr;
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true; return;
        }
        string AdvPositionName = this.txtAdvPositionName.Text;
        int ShowType = int.Parse(this.txtShowType.Text);
        int RepeatColumns = int.Parse(this.txtRepeatColumns.Text);
        int Width = int.Parse(this.txtWidth.Text);
        int Height = int.Parse(this.txtHeight.Text);
        string AdvHtml = this.txtAdvHtml.Text;


        StringBuilder strSql = new StringBuilder();
        strSql.Append("update AdvPositions set ");
        strSql.Append("AdvPositionName=@AdvPositionName,");
        strSql.Append("ShowType=@ShowType,");
        strSql.Append("RepeatColumns=@RepeatColumns,");
        strSql.Append("Width=@Width,");
        strSql.Append("Height=@Height,");
        strSql.Append("AdvHtml=@AdvHtml");
        strSql.Append(" where AdvPositionId=@AdvPositionId");
        OleDbParameter[] parameters = {
					new OleDbParameter("@AdvPositionName", OleDbType.Char,100),
					new OleDbParameter("@ShowType", DbType.Int32),
					new OleDbParameter("@RepeatColumns", DbType.Int32),
					new OleDbParameter("@Width", DbType.Int32),
					new OleDbParameter("@Height", DbType.Int32),
					new OleDbParameter("@AdvHtml", OleDbType.Char,0),
					new OleDbParameter("@AdvPositionId", DbType.Int32)};
        parameters[0].Value = AdvPositionName;
        parameters[1].Value = ShowType;
        parameters[2].Value = RepeatColumns;
        parameters[3].Value = Width;
        parameters[4].Value = Height;
        parameters[5].Value = AdvHtml;
        parameters[6].Value = (int)Session["id"];
        try
        {
            int rows = DBUtility.DbHelperOleDb.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                Messageshow1.Msg = "广告位修改成功！";
                Messageshow1.Infotype = "1";
                Messageshow1.Visible = true;
            }
            else
            {
                Messageshow1.Msg = "广告位修改失败！";
                Messageshow1.Infotype = "2";
                Messageshow1.Visible = true;
            }
        }
        catch 
        {
            Messageshow1.Msg = "广告位修改失败,请重新选择需要修改的广告位！";
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true;
        }
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        Response.Redirect("advert_position_manage.aspx");
    }
}
