﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class system_downloads_manage : RePage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            try
            {
                init();
                if (Session["curpage"] == null)
                    search(txstarttime.Value.Trim(), txendtime.Value.Trim(), txcategores.SelectedValue.Trim(), txtitle.Text.Trim(), 1, 20);
                else
                    search(txstarttime.Value.Trim(), txendtime.Value.Trim(), txcategores.SelectedValue.Trim(), txtitle.Text.Trim(), (int)Session["curpage"], 20);
            }
            catch
            {
                Messageshow1.Infotype = "2";
                Messageshow1.Msg = "数据加载失败";
                Messageshow1.Visible = true;
            }
        }
    }
    #region init
    void init()
    {
        DataSet myset = DBUtility.DbHelperOleDb.Query("select * from part order by lft");
        txcategores.DataSource = myset.Tables[0];
        txcategores.DataTextField = "Name";
        txcategores.DataValueField = "CategoryId";
        txcategores.DataBind();
        ListItem item = new ListItem();
        item.Text = "所有分类";
        item.Value = "-1";
        txcategores.Items.Insert(0, item);
        if (Request.QueryString["id"] != null)
        {
            txcategores.ClearSelection();
            for (int i = 0; i < txcategores.Items.Count; i++)
            {
                if (txcategores.Items[i].Value.Trim() == Request.QueryString["id"])
                {
                    txcategores.SelectedIndex = i;
                    break;
                }
            }
        }
        else
        {
            if (Session["txstarttime"] != null)
            {
                txstarttime.Value = (string)Session["txstarttime"];
                Session.Remove("txstarttime");
            }
            if (Session["txendtime"] != null)
            {
                txendtime.Value = (string)Session["txendtime"];
                Session.Remove("txendtime");
            }

            if (Session["txgradindex"] != null)
            {
                txcategores.ClearSelection();
                for (int i = 0; i < txcategores.Items.Count; i++)
                {
                    if (txcategores.Items[i].Value.Trim() == Session["txgradindex"].ToString())
                    {
                        txcategores.SelectedIndex = i;
                        break;
                    }
                }
                Session.Remove("txgradindex");
            }

            if (Session["txtitle"] != null)
            {
                txtitle.Text = (string)Session["txtitle"];
                Session.Remove("txtitle");
            }
        }
    }
    #endregion
    #region search
    void search(string datestart, string dateend, string categores, string title, int curpage, int pagesize)
    {
        OleDbConnection con = new OleDbConnection(theconnectstring.constring);
        OleDbCommand cmd = new OleDbCommand();
        cmd.Connection = con;
        con.Open();
        string strWhere = "";
        if (!string.IsNullOrEmpty(datestart))
        {
            strWhere += " and AddedDate >= #" + Convert.ToDateTime(datestart) + "#";
        }
        if (!string.IsNullOrEmpty(dateend))
        {
            strWhere += " and AddedDate <= #" + Convert.ToDateTime(dateend) + "#";
        }
        if (!string.IsNullOrEmpty(categores))
        {
            if (!categores.Trim().Equals("-1"))
                strWhere += " and CategoryId = " + Convert.ToInt32(categores) + "";
        }
        if (!string.IsNullOrEmpty(title))
        {
            strWhere += " and Title like '%" + title + "%'";
        }

        cmd.CommandText = "select count(DownloadId) as cnt from Downloads where 1=1 " + strWhere + "";
        OleDbDataReader reader = cmd.ExecuteReader();
        reader.Read();
        thepager.RecordCount = Convert.ToInt32(reader["cnt"].ToString());
        reader.Close();
        con.Close();
        if (Session["curpage"] != null)
        {
            curpage = thepager.CurrentPageIndex = (int)Session["curpage"];
            Session.Remove("curpage");
        }
        OleDbDataAdapter myda = new OleDbDataAdapter();
        if (curpage == 1)
        {
            cmd.CommandText = "select top " + pagesize + " * from Downloads where 1=1 " + strWhere + "  order by AddedDate desc,DownloadId  desc ";
        }
        else
        {
            cmd.CommandText = "select top " + pagesize + " * from Downloads where( 1=1 " + strWhere + " and DownloadId not in (select top " + pagesize * (curpage - 1) + " DownloadId from Downloads where news_id <> 0 " + strWhere + " order by AddedDate desc,DownloadId  desc )) order by AddedDate desc,DownloadId  desc ";
        }
        myda.SelectCommand = cmd;
        DataSet ds = new DataSet();
        con.Open();
        myda.Fill(ds);
        con.Close();
        Repeater1.DataSource = ds.Tables[0];
        Repeater1.DataBind();
    }
    #endregion

    protected void edit(object sender, EventArgs e)
    {
        int id;
        id = Convert.ToInt32(((Button)sender).CommandArgument);
        Session["id"] = Convert.ToInt32(((Button)sender).CommandArgument);
        Session["txstarttime"] = txstarttime.Value;
        Session["txendtime"] = txendtime.Value;
        Session["txgradindex"] = txcategores.SelectedValue;
        Session["txtitle"] = txtitle.Text;
        Session["curpage"] = thepager.CurrentPageIndex;
        Response.Redirect("downloads_edit.aspx?id=" + Request.QueryString["id"] + "&type=" + Request.QueryString["type"]);
    }

    protected void delete(object sender, EventArgs e)
    {
        try
        {
            int id;
            id = Convert.ToInt32(((Button)sender).CommandArgument);
            OleDbConnection con = new OleDbConnection(theconnectstring.constring);
            OleDbCommand cmd = new OleDbCommand("delete from [Downloads] where DownloadId=?", con);
            cmd.Parameters.Add("DownloadId", id);
            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
            search(txstarttime.Value.Trim(), txendtime.Value.Trim(), txcategores.SelectedValue.Trim(), txtitle.Text.Trim(), thepager.CurrentPageIndex, 20);
            Messageshow1.Infotype = "1";
            Messageshow1.Msg = "删除成功";
            Messageshow1.Visible = true;
        }
        catch
        {
            Messageshow1.Infotype = "2";
            Messageshow1.Msg = "删除失败";
            Messageshow1.Visible = true;
        }
    }

    protected void txdel_Click(object sender, EventArgs e)
    {
        try
        {
            OleDbConnection con = new OleDbConnection(theconnectstring.constring);
            foreach (RepeaterItem item in Repeater1.Items)
            {
                CheckBox _checkbox = (CheckBox)item.FindControl("CheckBox1");
                if (_checkbox.Checked)
                {
                    int id;
                    id = Convert.ToInt32(_checkbox.Text);
                    OleDbCommand cmd = new OleDbCommand("delete from [Downloads] where DownloadId=?", con);
                    cmd.Parameters.Add("DownloadId", id);
                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }
            }
            search(txstarttime.Value.Trim(), txendtime.Value.Trim(), txcategores.SelectedValue.Trim(), txtitle.Text.Trim(), thepager.CurrentPageIndex, 20);
            Messageshow1.Infotype = "1";
            Messageshow1.Msg = "删除成功";
            Messageshow1.Visible = true;
        }
        catch
        {
            Messageshow1.Infotype = "2";
            Messageshow1.Msg = "删除失败";
            Messageshow1.Visible = true;
        }
    }

    protected void LinkButton1_Click(object sender, EventArgs e)
    {
        try
        {
            search(txstarttime.Value.Trim(), txendtime.Value.Trim(), txcategores.SelectedValue.Trim(), txtitle.Text.Trim(), thepager.CurrentPageIndex, 20);
            Messageshow1.Infotype = "0";
            Messageshow1.Msg = "执行刷新操作成功";
            Messageshow1.Visible = true;
        }
        catch
        {
            Messageshow1.Infotype = "2";
            Messageshow1.Msg = "执行刷新操作失败";
            Messageshow1.Visible = true;
        }
    }

    protected void thepager_PageChanged(object sender, EventArgs e)
    {
        search(txstarttime.Value.Trim(), txendtime.Value.Trim(), txcategores.SelectedValue.Trim(), txtitle.Text.Trim(), thepager.CurrentPageIndex, 20);
    }

    protected void searchbut_Click(object sender, EventArgs e)
    {
        try
        {
            search(txstarttime.Value.Trim(), txendtime.Value.Trim(), txcategores.SelectedValue.Trim(), txtitle.Text.Trim(), 1, 20);
        }
        catch
        {
            Messageshow1.Infotype = "2";
            Messageshow1.Msg = "加载数据失败";
            Messageshow1.Visible = true;
        }
    }
    public string articlecategoresname(string CategoryId)
    {
        string name = "";
        OleDbConnection con = new OleDbConnection(theconnectstring.constring);
        OleDbCommand cmd = new OleDbCommand("select * from part where CategoryId=" + CategoryId + "", con);
        con.Open();
        OleDbDataReader reader = cmd.ExecuteReader();
        if (reader.HasRows)
        {
            reader.Read();
            name = reader["Name"].ToString();
            reader.Close();
        }
        con.Close();
        return name;
    }
}