﻿using System;
using MsShop.Common;
using System.Text;
using System.Data.OleDb;
using System.Data;

public partial class faq_edit : RePage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            try
            {
                StringBuilder strSql = new StringBuilder();
                strSql.Append("select * from faq ");
                strSql.Append(" where Id=@Id");
                OleDbParameter[] parameters = {
					new OleDbParameter("@Id", OleDbType.Integer)
			};
                parameters[0].Value = (int)Session["id"];
                DataSet ds = DBUtility.DbHelperOleDb.Query(strSql.ToString(), parameters);
                if (ds.Tables[0].Rows.Count > 0)
                {


                    txtproblem.Text = ds.Tables[0].Rows[0]["problem"].ToString();
                    txtFrequency.Text = ds.Tables[0].Rows[0]["Sort"].ToString();
                    txtAnswer.Text = ds.Tables[0].Rows[0]["Answer"].ToString();
                }
            }
            catch
            {
                Messageshow1.Msg = "信息加载失败,请重新选择修改";
                Messageshow1.Infotype = "0";
                Messageshow1.Visible = true;
            }
        }
    }

    protected void Button7_Click(object sender, EventArgs e)
    {
        Response.Redirect("faq_manage.aspx");
    }

    protected void Button6_Click(object sender, EventArgs e)
    {
        string strErr = "";
        if (this.txtproblem.Text.Trim().Length == 0)
        {
            strErr += "问题不能为空！";
        }
        if (!PageValidate.IsNumber(txtFrequency.Text))
        {
            strErr += "排序码格式错误！";
        }

        if (strErr != "")
        {
            Messageshow1.Msg = strErr;
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true;
            return;
        }

        string Keywords = this.txtproblem.Text;
        int Frequency = int.Parse(this.txtFrequency.Text);
        string Answer = this.txtAnswer.Text;
        StringBuilder strSql = new StringBuilder();
        strSql.Append("update faq set ");
        strSql.Append("Problem=@Problem,");
        strSql.Append("Answer=@Answer,");
        strSql.Append("Sort=@Sort");
        strSql.Append(" where Id=@Id");
        OleDbParameter[] parameters = {
					new OleDbParameter("@Problem", OleDbType.Char,0),
					new OleDbParameter("@Answer",OleDbType.Char,0),
					new OleDbParameter("@Sort", OleDbType.Integer),
					new OleDbParameter("@Id", OleDbType.Integer)};
        parameters[0].Value = Keywords;
        parameters[1].Value = Answer;
        parameters[2].Value = Frequency;
        parameters[3].Value = (int)Session["id"];

        int rows = DBUtility.DbHelperOleDb.ExecuteSql(strSql.ToString(), parameters);
        if (rows>0)
        {
            Messageshow1.Msg = "修改成功！";
            Messageshow1.Infotype = "1";
            Messageshow1.Visible = true;
        }
        else
        {
            Messageshow1.Msg = "修改失败！";
            Messageshow1.Infotype = "2";
            Messageshow1.Visible = true;
        }
    }
}
