﻿using System;
using System.Web.UI.WebControls;
using System.Text;
using System.Collections;
using System.Data.OleDb;
using DBUtility;
using System.Data;
using System.Collections.Generic;

public partial class products_manage : RePage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            try
            {
                init();
                search(CategoriesDrop1.SelectedValue.Trim(), txtitle.Text.Trim());
            }
            catch
            {
                Messageshow1.Infotype = "2";
                Messageshow1.Msg = "数据加载失败";
                Messageshow1.Visible = true;
            }
        }
    }
    #region init
    void init()
    {
        Loaddata();
        if (Session["txgradindex"] != null)
        {
            CategoriesDrop1.SelectedIndex = Convert.ToInt32(Session["txgradindex"]);
            Session.Remove("txgradindex");
        }
        if (Session["txtitle"] != null)
        {
            txtitle.Text = (string)Session["txtitle"];
            Session.Remove("txtitle");
        }
    }
    #endregion
    #region search
    void search(string categores, string title)
    {
        StringBuilder strwhere = new StringBuilder("1=1");
        if (!string.IsNullOrEmpty(categores))
        {
            if (!categores.Trim().Equals("0"))
                strwhere.Append(" and b.CategoryId=" + categores);
        }
        if (!string.IsNullOrEmpty(title))
        {
            strwhere.Append(" and b.name like \"%" + title + "%\"");
        }
        StringBuilder strSql = new StringBuilder();
        strSql.Append("select count(1) FROM Products b");
        if (strwhere.ToString().Trim() != "")
        {
            strSql.Append(" where " + strwhere);
        }
        object obj = DbHelperOleDb.GetSingle(strSql.ToString());
        if (obj == null)
        {
            thepager.RecordCount = 0;
        }
        else
        {
            thepager.RecordCount = Convert.ToInt32(obj);
        }
        if (Session["curpage"] != null)
        { thepager.CurrentPageIndex = (int)Session["curpage"]; Session.Remove("curpage"); }
        if (thepager.CurrentPageIndex == 1)
        {
            Repeater1.DataSource = DbHelperOleDb.Query(string.Format("select top {0} a.Name as CName,b.* from Categories a,Products b where {1} and a.CategoryId=b.CategoryId order by {2} ", thepager.PageSize, strwhere, "b.lft,b.sort,b.ProductId"));
        }
        else
        {
            Repeater1.DataSource = DbHelperOleDb.Query(string.Format("select top {0} a.Name as CName,b.* from Categories a,Products b where {1} and a.CategoryId=b.CategoryId and b.Productid not in (select top  {3} ProductId from Products b where {1}  order by {2} )  order by {2} ", thepager.PageSize, strwhere, "b.lft,b.sort,b.ProductId", thepager.PageSize * (thepager.CurrentPageIndex-1)));
        }
        Repeater1.DataBind();
    }
    #endregion

    protected void delete(object sender, EventArgs e)
    {
        try
        {
            Button lbtn_Update = (Button)sender;
            int id = Convert.ToInt32(((Button)sender).CommandArgument);
            RepeaterItem ri = (RepeaterItem)lbtn_Update.NamingContainer;
            string iconurl = ((Literal)ri.FindControl("iconurl")).Text;
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from Products ");
            strSql.Append(" where ProductId=@ProductId");
            OleDbParameter[] parameters = {
					new OleDbParameter("@ProductId", OleDbType.Integer)
			};
            parameters[0].Value = id;

            int rows = DbHelperOleDb.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                if (iconurl.Length > 0)
                {
                    Picindex.DelPic(iconurl, "/productimage/products/big/");
                    Picindex.DelPic(iconurl, "/productimage/products/small/");
                }
                search(CategoriesDrop1.SelectedValue.Trim(), txtitle.Text.Trim());
                Messageshow1.Infotype = "1";
                Messageshow1.Msg = "删除成功";
                Messageshow1.Visible = true;
            }
            else
            {
                Messageshow1.Infotype = "2";
                Messageshow1.Msg = "删除失败";
                Messageshow1.Visible = true;
            }
        }
        catch
        {
            Messageshow1.Infotype = "2";
            Messageshow1.Msg = "删除失败";
            Messageshow1.Visible = true;
        }
    }

    protected void txdel_Click(object sender, EventArgs e)
    {
        StringBuilder ids = new StringBuilder();
        StringBuilder iconurls = new StringBuilder();
        foreach (RepeaterItem item in Repeater1.Items)
        {
            CheckBox _checkbox = (CheckBox)item.FindControl("CheckBox1");
            Literal _iconurl = (Literal)item.FindControl("iconurl");
            if (_iconurl.Text.Length > 4)
            {
                iconurls.Append(_iconurl.Text);
                iconurls.Append("|");
            }
            if (_checkbox.Checked)
            {
                ids.Append(_checkbox.Text);
                ids.Append(",");
            }
        }
        if (ids.Length > 0)
        {
            string idsstr = StringHelper.Removestrright(ids.ToString(), 1);
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from Products ");
            strSql.Append(" where ProductId in (" + idsstr + ")  ");
            int rows = DbHelperOleDb.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                if (iconurls.Length > 0)
                {
                    string iconurlsstr = StringHelper.Removestrright(iconurls.ToString(), 1);
                    Picindex.DelPic(iconurlsstr, "/productimage/products/big/");
                    Picindex.DelPic(iconurlsstr, "/productimage/products/small/");
                }
                search(CategoriesDrop1.SelectedValue.Trim(), txtitle.Text.Trim());
                Messageshow1.Infotype = "1";
                Messageshow1.Msg = "删除成功";
                Messageshow1.Visible = true;
            }
            else
            {
                Messageshow1.Infotype = "2";
                Messageshow1.Msg = "删除失败!";
                Messageshow1.Visible = true;
            }
        }
        else
        {
            Messageshow1.Infotype = "0";
            Messageshow1.Msg = "未选择任何数据!";
            Messageshow1.Visible = true;
        }
    }

    protected void LinkButton1_Click(object sender, EventArgs e)
    {
        try
        {
            ArrayList sqllist = new ArrayList(Repeater1.Items.Count);
            foreach (RepeaterItem item in Repeater1.Items)
            {
                Button _botton = (Button)item.FindControl("Button3");
                TextBox _sort = (TextBox)item.FindControl("sort");
                sqllist.Add("update Products set sort=" + _sort.Text + " where ProductId=" + _botton.CommandArgument);
            }
            if (DbHelperOleDb.ExecuteSqlTran(sqllist))
            {
                search(CategoriesDrop1.SelectedValue.Trim(), txtitle.Text.Trim());
                Messageshow1.Infotype = "1";
                Messageshow1.Msg = "执行刷新操作成功";
                Messageshow1.Visible = true;
            }
            else
            {
                Messageshow1.Infotype = "2";
                Messageshow1.Msg = "执行刷新操作失败";
                Messageshow1.Visible = true;
            }
        }
        catch
        {
            Messageshow1.Infotype = "2";
            Messageshow1.Msg = "系统错误";
            Messageshow1.Visible = true;
        }
    }

    protected void thepager_PageChanged(object sender, EventArgs e)
    {
        search(CategoriesDrop1.SelectedValue.Trim(), txtitle.Text.Trim());
    }

    protected void searchbut_Click(object sender, EventArgs e)
    {
        try
        {
            Session["txgradindex"] = CategoriesDrop1.SelectedIndex.ToString().Trim();
            Session["txtitle"] = txtitle.Text.Trim();
            Session["curpage"] = 1;
            search(CategoriesDrop1.SelectedValue.Trim(), txtitle.Text.Trim());
        }
        catch
        {
            Messageshow1.Infotype = "2";
            Messageshow1.Msg = "加载数据失败";
            Messageshow1.Visible = true;
        }
    }
    #region 类别管理
    public void Loaddata()
    {
        if (!Page.IsPostBack)
        {
            DataSet categores = DbHelperOleDb.Query("select CategoryId,Lft,Rgt,Depart,Name,LinkUrl,Title,Meta_Description,Meta_Keywords,Description,Content,isshow,opflag from Categories order by Lft");
            ListItem topitem = new ListItem("\u3000\u3000\u3000\u3000", "0");
            CategoriesDrop1.Items.Add(topitem);
            foreach (DataRow c2 in categores.Tables[0].Rows)
            {
                ListItem item = new ListItem();
                StringBuilder blank = new StringBuilder();
                int i = 1;
                while (true)
                {
                    int num = i;
                    if (!(num <= (int)c2["Depart"] - 1))
                    {
                        break;
                    }
                    blank.Append("\u3000");
                    i++;
                }
                item.Text = blank.ToString() + c2["Name"].ToString().Trim();
                item.Value = c2["CategoryId"].ToString();
                CategoriesDrop1.Items.Add(item);
            }
        }
    }
    public void ReLoaddata()
    {
        int selitem = CategoriesDrop1.SelectedIndex;
        CategoriesDrop1.Items.Clear();
        DataSet categores = DbHelperOleDb.Query("select CategoryId,Lft,Rgt,Depart,Name,LinkUrl,Title,Meta_Description,Meta_Keywords,Description,Content,isshow,opflag from Categories order by Lft");
        ListItem topitem = new ListItem("\u3000\u3000\u3000\u3000", "0");
        CategoriesDrop1.Items.Add(topitem);
        foreach (DataRow c2 in categores.Tables[0].Rows)
        {
            ListItem item = new ListItem();
            StringBuilder blank = new StringBuilder();
            int i = 1;
            while (true)
            {
                int num = i;
                if (!(num <= (int)c2["Depart"] - 1))
                {
                    break;
                }
                blank.Append("\u3000");
                i++;
            }
            item.Text = blank.ToString() + c2["Name"].ToString().Trim();
            item.Value = c2["CategoryId"].ToString();
            CategoriesDrop1.Items.Add(item);
        }
        CategoriesDrop1.SelectedIndex = selitem;
    }
    #endregion
}